<?php

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

$alphaIndex = array ( "]","A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z","[" );



class mosjbd {

    /**
    * Get actual version information
    */
    function getVersion($full=true) {
       return ($full) ? 'v1.0' : 'v1.0';
    }

}



/**
* Category database table class
*/
class mosbusiness extends mosDBTable {


      /** @var int Primary key */
    var $id=null;

      /** @var int */
    var $sid=null;

      /** @var string */
    var $title=null;

      /** @var string */
    var $url=null;

      /** @var string */
    var $description=null;

      /** @var string */
    var $detail=null;

      /** @var string */
    var $imageurl=null;

      /** @var datetime */
    var $created=null;

      /** @var datetime */
    var $modified=null;

      /** @var int */
    var $hits=null;

      /** @var int */
    var $published=null;

      /** @var int */
    var $access=null;

      /** @var int */
    var $ordering=null;

      /** @var boolean */
    var $checked_out=null;

      /** @var time */
    var $checked_out_time=null;

      /** @var int */
    var $archived=null;

      /** @var int */
    var $approved=null;

      /** @var int */
    var $rating=null;

      /** @var int */
    var $ratingcount=null;

      /** @var int */
    var $ratingadmin=null;

      /** @var int */
    var $created_by=null;

      /** @var string */
    var $validated=null;

      /** @var time */
    var $validationdate=null;

      /** @var string */
    var $validationstatus=null;

      /** @var int */
    var $redirect=null;

      /** @var int */
    var $private=null;

      /** @var int */
    var $openwin=null;

      /** @var text */
    var $keywords=null;

      /** @var integer */
    var $credits=null;



// -----------------------

    /**
    * @param database A database connector object
    */
    function mosbusiness( &$db ) {
        $this->mosDBTable( '#__jbd', 'id', $db );
    }

// -----------------------

    // *** Check & Validation
    function check() {
        // *** Check for valid Title (not empty) => Mainly for SEF support
        if (trim( $this->title ) == '') {
            $this->_error = _BM_business_MUST_HAVE_TITLE;
            return false;
        }

        // *** Check for Empty URL
        $params->checkemptyurl = mosjbdTools::getPref(-1,'params','checkemptyurl', '0');
        if ($params->checkemptyurl) {
           if (trim( $this->url ) == '') {
               $this->_error = _BM_business_MUST_HAVE_URL;
               return false;
           }
        }

        // *** Check if protocol is entered, otherwise add "http://" in front...
        mosjbdTools::verifyProtocol($this->url);

        $errors = array();

        // *** Check for Title Duplicates
        $params->checkduplicatetitle = mosjbdTools::getPref(-1,'params','checkduplicatetitle', '1');
        if ($params->checkduplicatetitle && $this->title) {
           $wheres = array();
           $wheres[] = "title = '".$this->title."'";     // To verify if this Title is already present => Ensure unique Title (no duplicate). !!! Note : Not checked when importing !!!
           $where = '(' . implode( ') '."\n".' OR (', $wheres ) . ')';

           // *** Check for existing name & Existing URL
           $Query = "SELECT id"
               . "\n FROM #__jbd"
               . "\n WHERE $where"
           ;

           $this->_db->setQuery($Query);
           $xid1 = intval( $this->_db->loadResult() );
           if ($xid1 && $xid1 != intval( $this->id )) {
               $errors[] = _BM_business_EXIST ." (ID [$xid1])";
           }
        }

        // *** Check for URL Duplicates
        $params->checkduplicateurl = mosjbdTools::getPref(-1,'params','checkduplicateurl', '1');
        if ($params->checkduplicateurl && $this->url) {  // Note : Empty URLs are allowed to be duplicates !
           $wheres = array();
           $wheres[] = "url = '".$this->url."'";     // To verify if this URL is already present => Ensure unique URL (no duplicate). !!! Note : Not checked when importing !!!
           $where = '(' . implode( ') '."\n".' OR (', $wheres ) . ')';

           // *** Check for existing name & Existing URL
           $Query = "SELECT id"
               . "\n FROM #__jbd"
               . "\n WHERE $where"
           ;

           $this->_db->setQuery($Query);
           $xid2 = intval( $this->_db->loadResult() );
           if ($xid2 && $xid2 != intval( $this->id )) {
               $errors[] .= _BM_business_EXIST_URL ." (ID [$xid2])";
           }
        }

        $valid = (count($errors)==0) ? true : false;     // Validation successfull if no error...
        $this->_error = implode( "    &    ", $errors );

        return $valid;
    }

// -----------------------

    /**
    * @param string Load Custom field that are not present in the Class table variables list (mosDBTable Extension)
    */
    function loadCustom ( $uid=0 ) {
           global $my;

           // look for custom fields, as they are not loaded with default "$row->load($id)" function as teh fields are not listed in the mosTable extension.
           $this->_db->setQuery( "SELECT CONCAT('f_',c.name) as fname, c.*"
                            . "\n FROM #__jbd_columns AS c"
                            . "\n WHERE c.category = ''"
                            . "\n AND c.custom = '1'"
                            . "\n ORDER BY c.ordering"
           );
           $fields =  $this->_db->loadObjectList();

           if ($fields) {  // Any Custom fields to retrieve ?

              $fieldlist = '';
              foreach ($fields as $field) {         // Build Custom Field lists
                 if ($fieldlist) { $fieldlist .= ', '; }
                 $fieldlist .= $field->fname;
              }

              if ($fieldlist) {
                 $this->_db->setQuery( "SELECT $fieldlist"     // Retrieve custom values (same order as the retrieved Custom Fields for easy array manipulations...)
                                  . "\n FROM #__jbd AS b"
                                  . "\n WHERE b.id = '$uid'"
                 );
                 $this->_db->loadObject($custom);

                 if ($custom) {      // Found values => Copy them to business object
                    foreach ($fields as $field) {
                       $cname = $field->fname;
                       $field->value = $custom->$cname;
                       $this->$cname = $field;
                    }
                 } else {            // New Record : create empty structure
                    foreach ($fields as $field) {
                         $cname = $field->fname;       // Retrieve the field name
                         switch ($field->f_type) {
                           case "3" : // INT
                           case "4" : // BOOLEAN
                           case "8" : // RATE
                               $field->value = 0;      // Numeric : Set to "0"
                               break;
                           default :
                               $field->value = "";     // String : Set to empty
                         }
                         $this->$cname = $field;       // Copy full custom field details to jbd object
                    }
                 }
              }
           }
    }

// -----------------------

    // *** Record the hit
    function hit ($option, $Itemid, $info=false) {
        global $my;

        $date = date( "Y-m-d H:i:s" );  // Time : set to "Now"

        // get Agenttype
        $browser = "";
        $useragent = "";
        $agenttype = mosjbdTools::checkBrowserOrBot($browser, $useragent);

        if ( $agenttype == 2 ) {  // !!! We have detected a Search Robot, so do not count it's visit and do not Validate url !
           if ($info) {
              echo "NO HIT COUNT and VALIDATION ! : [".$this->id."] <b>".$this->title."</b><br />\n";
              echo "Search Bot/Crawler/Spider identified : [<b>$browser</b>] => [$useragent])<br />\n";
           }
        } else {  // *** Valid userAgent => Ok to process Hit count and Validation

           // *** Hit Count
           if ( $info ) { echo "Hit count : [".$this->id."] <b>".$this->title."</b><br />\n"; }

           // *** Need to integrate a filter to allow hit computation only every n hours, to avoid cheating hit increase. See "Vote" protection (IP or ID) and based on time.
           // *** Use the Vote table by adding 2 fields : "Hit status" and "time of the hit".
           // *** This will allow to filter if hit is already computed for a specific user or visitor (IP) and can compute again if the protection delay is expired.
           // *** => This will provide a "Usage tracking" system for each users.

           $params->trackusers = mosjbdTools::getPref(-1,'params','trackusers', '0');
           $params->hitsdelay = mosjbdTools::getPref(-1,'params','hitsdelay', '0');
           $params->cancredit = mosjbdTools::getPref(-1,'params','cancredit', '0');
           $params->reducerating = mosjbdTools::getPref(-1,'params','reducerating', '-1');

           if ($params->trackusers) {    // Tracking enabled => Save user activity trace (hits count and last hit's date).

              if ($my->id) {
                   $sqlfilter = "\n AND (bv.userid = $my->id)";
                   $host = '';
              } else {
                   if (phpversion() <= "4.2.1") {
                       $host = gethostbyaddr( getenv( "REMOTE_ADDR" ) );
                   } else {
                       $host = gethostbyaddr( $_SERVER['REMOTE_ADDR'] );
                   }
                   $sqlfilter = "\n AND (bv.host = '$host')";
              }

              // *** Get tracking record
              $this->_db->setQuery("SELECT bv.id, bv.itemid, bv.hits, bv.hitsdate"
                              . "\n FROM #__jbd_vote AS bv"
                              . "\n WHERE (bv.itemid = $this->id)"
                              . $sqlfilter
              );

              $this->_db->loadObject($track);

              // Check delay since last Hits
              if ($track) {
                 $elapsed = floor( ( ( strtotime($date) - strtotime($track->hitsdate) ) ) * 1000 ) / 1000 ; // Elapsed time since last validation (in seconds)
              } else {
                 $elapsed = 0;
              }

              // *** Compute only if no hits counted, hits protection delay is disabled or hits delay is expired
              if ($params->hitsdelay == 0 || !$track || $track->hits == 0 || ($track->hits > 0 && $elapsed > $params->hitsdelay) ) {

                 // *** Hit count
                 $this->_db->setQuery( "UPDATE #__jbd SET hits = '".($this->hits+1)."' WHERE id = '".$this->id."'" );                       // Update jbd : Manual increase... More compatible...
                 if (!$this->_db->query()) {
                    echo "<script type='text/javascript'>alert('ERROR : ".$this->_db->getErrorMsg()."'); window.history.go(-1);</script>\n";
                    exit;
                 }

                 // *** Credits removal
                 if ($params->cancredit && $this->credits > 0 && $my->usertype != "Super Administrator") {
                    $this->_db->setQuery( "UPDATE #__jbd SET credits = '".($this->credits-1)."' WHERE id = '".$this->id."'" );     // Manual decrease... More compatible...
                    if (!$this->_db->query()) {
                       echo "<script type='text/javascript'>alert('ERROR : ".$this->_db->getErrorMsg()."'); window.history.go(-1);</script>\n";
                       exit;
                    }
                    if ($this->credits == 1 && $params->reducerating) { // Processing the last credit (but already set to "0"), but need to reduce the RatingAdmin...
                       if ($params->reducerating == 1) {
                          $this->_db->setQuery( "UPDATE #__jbd SET ratingadmin = '0' WHERE id = '".$this->id."'" );     // Force to Standard
                          if (!$this->_db->query()) {
                             echo "<script type='text/javascript'>alert('ERROR : ".$this->_db->getErrorMsg()."'); window.history.go(-1);</script>\n";
                             exit;
                          }
                       } elseif ($params->reducerating == 2) {
                          $this->_db->setQuery( "UPDATE #__jbd SET ratingadmin = '".($this->ratingadmin-1)."' WHERE id = '".$this->id."'" );     // Reduce RatingAdmin
                          if (!$this->_db->query()) {
                             echo "<script type='text/javascript'>alert('ERROR : ".$this->_db->getErrorMsg()."'); window.history.go(-1);</script>\n";
                             exit;
                          }
                       }

                    }
                 }

                 // *** Tracking user
                 if ($track) {  // Is the record already present (voted or hits) ?
                    $this->_db->setQuery( "UPDATE #__jbd_vote SET hitsdate='$date', hits='".($track->hits+1)."' WHERE id='".$track->id."'" );  // Update Track : Manual increase... More compatible...
                 } else {
                    if ($my->id) {
                       $this->_db->setQuery( "INSERT INTO #__jbd_vote (itemid, userid, hits, hitsdate) VALUES ($this->id, '$my->id', '1', '$date')" );     // Create Track record (User)
                    } else {
                       $this->_db->setQuery( "INSERT INTO #__jbd_vote (itemid, host, hits, hitsdate) VALUES ($this->id, '$host', '1', '$date')" );         // Create Track record (Host)
                    }
                 }
                 if (!$this->_db->query()) {
                     echo "<script type='text/javascript'>alert('ERROR : ".$this->_db->getErrorMsg()."'); window.history.go(-1);</script>\n";
                     exit;
                 }

                 if ($info) { echo "<b>Computed</b> Hit [$my->id:$host] => Delay $elapsed > ".$params->hitsdelay." (seconds)<br />\n"; }

              } else {

                 if ($info) { echo "<b>Skipped</b> Hit [$my->id:$host] => Delay $elapsed < ".$params->hitsdelay." (seconds)<br />\n"; }

              }

           } else {  // No tracking => Compute hits at every call...

              // *** Hit count
              $this->_db->setQuery( "UPDATE #__jbd SET hits = '".($this->hits+1)."' WHERE id = '".$this->id."'" );     // Manual increase... More compatible...
              if (!$this->_db->query()) {
                  echo "<script type='text/javascript'>alert('ERROR : ".$this->_db->getErrorMsg()."'); window.history.go(-1);</script>\n";
                  exit;
              }

              // *** Credits removal
              if ($params->cancredit && $this->credits > 0 && $my->usertype != "Super Administrator") {
                 $this->_db->setQuery( "UPDATE #__jbd SET credits = '".($this->credits-1)."' WHERE id = '".$this->id."'" );     // Manual decrease... More compatible...
                 if (!$this->_db->query()) {
                    echo "<script type='text/javascript'>alert('ERROR : ".$this->_db->getErrorMsg()."'); window.history.go(-1);</script>\n";
                    exit;
                 }
                 if ($this->credits == 1 && $params->reducerating) { // Processing the last credit (but already set to "0"), but need to reduce the RatingAdmin...
                    if ($params->reducerating == 1) {
                       $this->_db->setQuery( "UPDATE #__jbd SET ratingadmin = '0' WHERE id = '".$this->id."'" );     // Force to Standard
                       if (!$this->_db->query()) {
                          echo "<script type='text/javascript'>alert('ERROR : ".$this->_db->getErrorMsg()."'); window.history.go(-1);</script>\n";
                          exit;
                       }
                    } elseif ($params->reducerating == 2) {
                       $this->_db->setQuery( "UPDATE #__jbd SET ratingadmin = '".($this->ratingadmin-1)."' WHERE id = '".$this->id."'" );     // Reduce RatingAdmin
                       if (!$this->_db->query()) {
                          echo "<script type='text/javascript'>alert('ERROR : ".$this->_db->getErrorMsg()."'); window.history.go(-1);</script>\n";
                          exit;
                       }
                    }

                 }
              }

           }
        } // *** Hit counted...

/*
        if ( $agenttype == 2 ) {  // !!! We have detected a Search Robot, so do not count it's visit and do not Validate url !
           if ($info) {
              echo "NO VALIDATION ! : [".$this->id."] <b>".$this->title."</b><br />\n";
              echo "Search Bot/Crawler/Spider identified : [<b>$browser</b>] => [$useragent])<br />\n";
           }
        } else {  // *** Valid userAgent => Ok to process Hit count and Validation
*/

           // *** URL Validation
           if ($info) { echo '=> URL : <a href="' .$this->url. '" target="_self">' .$this->url. '</a><br />'."\n"; }

           $params->urlautocheck = mosjbdTools::getPref(-1,'params','urlautocheck', '7');
           $params->regcaneditown = mosjbdTools::getPref(-1,'params','regcaneditown', '0');
           $params->urlautochecktimeout = mosjbdTools::getPref(-1,'params','urlautochecktimeout', '7');

           if ( $this->url != "" && $params->urlautocheck != '-1' && $this->validated != 1) {  // Perform validation if not disabled or not manually validated

              // *** Check and Validate URL...
              $elapsed = floor( ( ( strtotime($date) - strtotime($this->validationdate) ) / (60*60*24) ) * 1000 ) / 1000 ; // Elapsed time since last validation (in days)

              if ( $elapsed > $params->urlautocheck || $params->urlautocheck == '0' ) {        // Last validation is too old or always check => Rescan
                  mosjbdTools::validateURL($option, $Itemid, $this->id, $params, '' ,$info );
              }
           }

/*
        } // *** Url Validated...
*/
    }

// -----------------------

    /**
    * @param string Target search string  - Version for Mambo v4.5.0 - no more used in v4.5.1 ==> SearchBots !!!
    */
    function search( $text, $state='', $sectionPrefix='' ) {
       global $mosConfig_live_site;

        $text = trim( $text );
        if ($text == '') {
           return array();
        }

        $bmurl = $mosConfig_live_site."/index.php?option=com_jbd&task=view&id=";

        // ** Query to also return the category but not the unpublished or unapproved jbd and returns the URL to count the hits (throught the component)
        $this->_db->setQuery( "SELECT b.created AS created, b.title, CONCAT('{$bmurl}',b.id) AS href, b.description AS text, '1' AS browsernav,  CONCAT('{$sectionPrefix}jbd<br />[',bc.name,']') AS section"
                         . "\n FROM #__jbd_categories AS bc"
                         . "\n LEFT JOIN #__jbd_itemcat AS i ON i.catid = bc.id"
                         . "\n LEFT JOIN #__jbd AS b ON b.id = i.itemid"
                         . "\n WHERE (b.title LIKE '%$text%' OR b.description LIKE '%$text%' OR b.url LIKE '%$text%')"
                         . "\n AND (b.published=1 AND b.approved=1)"
                         . "\n AND bc.published=1"
                         . "\n ORDER BY created DESC"
        );

        return $this->_db->loadObjectList();
    }

}

/**
* Category database table class
*/
class mosbusinessCategory extends mosDBTable {
      /** @var int Primary key */
    var $id=null;
      /** @var string The menu title for the Category (view name)*/
    var $title=null;
      /** @var string The full name for the Category - Unique key*/
    var $name=null;
      /** @var string */
    var $image=null;
      /** @var int */
    var $image_position=null;
      /** @var string */
    var $icon=null;
      /** @var string */
    var $description=null;
      /** @var boolean */
    var $published=null;
      /** @var boolean */
    var $checked_out=null;
      /** @var time */
    var $checked_out_time=null;
      /** @var string */
    var $editor=null;
      /** @var int */
    var $access=null;
      /** @var int */
    var $ordering=null;
      /** @var int */
    var $parent=null;
      /** @var text */
    var $keywords=null;

// -----------------------

    /**
    * @param database A database connector object
    */
    function mosbusinessCategory( &$db ) {
        $this->mosDBTable( '#__jbd_categories', 'id', $db );
    }

// -----------------------

    // overloaded check function
    function check() {
        // check for valid name
        if (trim( $this->title ) == '') {
            $this->_error = _BM_business_CATEGORY_MUST_CONTAIN_NAME;
            return false;
        }
        // check for existing name
        $this->_db->setQuery( "SELECT id"
                         . "\n FROM #__jbd_categories"
                         . "\n WHERE title = ".'"' .$this->title.'"'
                         . "\n AND parent = ".$this->parent
        );

        $xid = $this->_db->loadResult() ;
        if ($xid && $xid != $this->id ) {
            $this->_error = _BM_business_CATEGORY_EXIST;
            return false;
        }
        return true;
    }

// -----------------------

    function loadByName( $name ) {
        $this->_db->setQuery( "SELECT * FROM #__jbd_categories WHERE name=\"$name\"" );
        return $this->_db->loadObject( $this );
    }

// -----------------------

    function loadById( $id ) {
        $this->_db->setQuery( "SELECT * FROM #__jbd_categories WHERE id='$id'" );
        return $this->_db->loadObject( $this );
    }

}


/**
* ItemCat database table class
*/
class mosbusinessItemCat extends mosDBTable {
    /** @var int Primary key */
    var $id=null;
    /** @var int Bookmak ID */
    var $itemid=null;
    /** @var int Category ID */
    var $catid=null;
    /** @var int */
    var $ordering=null;

// -----------------------

    /**
    * @param database A database connector object
    */
    function mosbusinessItemCat( &$db ) {
        $this->mosDBTable( '#__jbd_itemcat', 'id', $db );
    }

// -----------------------

    // overloaded check function
    function check() {
        return true;
    }

}

/**
* Vote database table class
*/
class mosbusinessVote extends mosDBTable {
    /** @var int Primary key */
    var $id=null;

    /** @var int business ID */
    var $itemid=null;

    /** @var int Host (IP or fqdn) */
    var $host=null;

    /** @var int user ID */
    var $userid=null;

    /** @var int */
    var $vote=null;

    /** @var int */
    var $votedate=null;

    /** @var int */
    var $hits=null;

    /** @var int */
    var $hitsdate=null;

// -----------------------

    /**
    * @param database A database connector object
    */
    function mosbusinessVote( &$db ) {
        $this->mosDBTable( '#__jbd_vote', 'id', $db );
    }

// -----------------------

    // overloaded check function
    function check() {
        return true;
    }

}

/**
* Category database table class
*/
class mosbusinessColumn extends mosDBTable {
    /** @var int Primary key */
    var $id=null;

    /** @var string The full name for the Category - Unique key*/
    var $name=null;

    /** @var int */
    var $visible=null;

    /** @var int */
    var $visibleedit=null;

    /** @var int */
    var $visibledetail=null;

    /** @var int */
    var $visibleinfobox=null;

    /** @var int */
    var $ordering=null;

    /** @var int */
    var $custom=null;

    /** @var string */
    var $title=null;

    /** @var int */
    var $f_type=null;

    /** @var int */
    var $f_length=null;

// -----------------------

    /**
    * @param database A database connector object
    */
    function mosbusinessColumn( &$db ) {
        $this->mosDBTable( '#__jbd_columns', 'id', $db );
    }

// -----------------------

    // *** Check & Validation
    function check() {
        // ** check for valid field content
        $this->name = trim( $this->name );
        if ($this->name  == '') {
            $this->_error = _BM_FIELD_MUST_HAVE_NAME;
            return false;
        }
        $this->name = ereg_replace(" ", "_", $this->name);
        $this->name = ereg_replace("'", "_", $this->name);
        $this->name = ereg_replace('"', "",  $this->name);
        $this->name = ereg_replace("\(", "",  $this->name);
        $this->name = ereg_replace("\)", "",  $this->name);

        $this->title = trim( $this->title );
        if ($this->title == '') {
            $this->_error = _BM_FIELD_MUST_HAVE_TITLE;
            return false;
        }

        // ** Check for existing name
        $this->_db->setQuery( "SELECT id"
                         . "\n FROM #__jbd_columns"
                         . "\n WHERE name = '".$this->name."'"
                         . "\n AND category = ''"
        );
        $xid = intval( $this->_db->loadResult() );
        if ($xid && $xid != intval( $this->id )) {
            $this->_error = _BM_FIELD_EXIST;
            return false;
        }
        return true;
    }

}


/*
***********************
***                 ***
***  ToolBox Class  ***
***                 ***
***********************
*/

class mosjbdTools{


   // *** Convert Quotes to alternate ['] => [\'] to avoid error in JavaScript Confusion between quotes inside the text...
   function SafeQuotes($txt, $checkparenthesis=true) {
     $txt = ereg_replace("\\\\'|\\'|'|&#39;|&#039;",     "\\"."'", $txt);
     $txt = ereg_replace('"|&#34;',     "\\"."'", $txt);
     if ($checkparenthesis) {
        $txt = ereg_replace("\(",    "\\"."(", $txt);
        $txt = ereg_replace("\)",    "\\".")", $txt);
     }
     $txt = ereg_replace("\n\r|\n|\r",  "", $txt);
     return $txt;
   }

// -----------------------

   function URLMaxSize($URL, $size=50, $pattern='...') {
     if ($size && strlen($URL) > $size) {
        $URL = substr($URL,0,$size) . $pattern;
     }
     return $URL;
   }

// -----------------------

   function verifyProtocol(&$url) {
      $protocols = split( ",", mosjbdTools::getPref(-1,'params','protocols', _BM_PROTOCOLS) );

      if ($url) {  // if not empty, check for valid protocol
         $prot = false;
         foreach ($protocols as $protocol) {
            if ( ( eregi( $protocol, $url ) ) ) {  // found a valid protocol...
               $prot = true;
               break;
            }
         }
         if ( !$prot ) { $url = "http://".$url; }  // Protocol missing or not in the list => add "http://"
      }
   }

// -----------------------

   // *** calculate elapsed time (in seconds!) Return and array of elapsed days, hours, mins, secs with start time, end time and difference.
   function calcElapsedDays($strtime) {

          $elapsed->time = $strtime;
          $elapsed->start = strtotime($strtime);
          $elapsed->end = time();
          $elapsed->days = 0;
          $elapsed->hours = 0;
          $elapsed->mins = 0;
          $elapsed->secs = 0;
          $diff = $elapsed->end - $elapsed->start;
          $elapsed->diff = $diff;
          $elapsed->daydec = 0;

          $sec_in_a_day = 86400;
          while ($diff >= $sec_in_a_day) { $elapsed->days++; $diff -= $sec_in_a_day; }
          $elapsed->daydec = floor($diff * 100 / 86400);
          $sec_in_an_hour = 3600;
          while ($diff >= $sec_in_an_hour) { $elapsed->hours++; $diff -= $sec_in_an_hour; }
          $sec_in_a_min = 60;
          while ($diff >= $sec_in_a_min) { $elapsed->mins++; $diff -= $sec_in_a_min; }
          $elapsed->secs = $diff;

          return $elapsed;
   }

// -----------------------

   function remove_tags ($text) {
      while ($text != strip_tags($text) ) {   // There are still Tags to remove...
         $text = strip_tags($text);           // => Removing tags
      }
     return $text;
   }

// -----------------------

   function cssClass ($class='') {
      // => mosjbdTools::cssClass($params->csscategory);

      if ($class) {
         return ' class="' .$class. '"';
      } else {
         return "";
      }
   }

// -----------------------

   function ValidationInfo (&$params, &$row, &$valid_status, &$valid_img) {
      global $mosConfig_live_site, $my;

      $elapsed = mosjbdTools::calcElapsedDays( $row->validationdate );

      // *** Prepare Validation Info (Image and Status)
      switch ($row->validated) {
        case "":
        case "0":
            $valid_status = _BM_VALIDATION_NOT_SCANNED;
            $valid_img = $mosConfig_live_site.'/components/com_jbd/images/'.'disabled.png';
            break;
        case "1":
/*
            $valid_status = _BM_VALIDATION_MANUALLYVALIDATED;
            $valid_img = $mosConfig_live_site.'/components/com_jbd/images/'.'publish_g.png';
            break;
*/
        case "200" :
        case "201" :
        case "202" :
        case "203" :
        case "204" :
            $valid_status = _BM_VALIDATION_OK_VALIDATED;
            if ($my->gid >= $params->validatedetail) { $valid_status .= ' <br />('. mosjbdTools::SafeQuotes($row->validationstatus). ' - ' .mosFormatDate($row->validationdate).' - '.$elapsed->days.' '._BM_DAYS.')'; }
            $valid_img = $mosConfig_live_site.'/components/com_jbd/images/'.'publish_g.png';
            break;
        case "300" :
        case "301" :
        case "302" :
        case "304" :
            $valid_status = _BM_VALIDATION_WARNING_VALIDATED;
            if ($my->gid >= $params->validatedetail) { $valid_status .= ' <br />('. mosjbdTools::SafeQuotes($row->validationstatus). ' - ' .mosFormatDate($row->validationdate).' - '.$elapsed->days.' '._BM_DAYS.')'; }
            $valid_img = $mosConfig_live_site.'/components/com_jbd/images/'.'publish_y.png';
            break;
        case "400" :
            $valid_status = _BM_VALIDATION_ERROR;
            if ($my->gid >= $params->validatedetail) { $valid_status .= ' <br />('. mosjbdTools::SafeQuotes($row->validationstatus). ' - ' .mosFormatDate($row->validationdate).' - '.$elapsed->days.' '._BM_DAYS.')'; }
            $valid_img = $mosConfig_live_site.'/components/com_jbd/images/'.'publish_x.png';
            break;
        case "401" :
            $valid_status = _BM_VALIDATION_WARNING_VALIDATED;
            if ($my->gid >= $params->validatedetail) { $valid_status .= ' <br />('. mosjbdTools::SafeQuotes($row->validationstatus). ' - ' .mosFormatDate($row->validationdate).' - '.$elapsed->days.' '._BM_DAYS.')'; }
            $valid_img = $mosConfig_live_site.'/components/com_jbd/images/'.'publish_y.png';
            break;
        case "403" :
        case "404" :
        case "405" :
        case "406" :
        case "408" :
        case "409" :
        case "410" :
            $valid_status = _BM_VALIDATION_ERROR;
            if ($my->gid >= $params->validatedetail) { $valid_status .= ' <br />('. mosjbdTools::SafeQuotes($row->validationstatus). ' - ' .mosFormatDate($row->validationdate).' - '.$elapsed->days.' '._BM_DAYS.')'; }
            $valid_img = $mosConfig_live_site.'/components/com_jbd/images/'.'publish_x.png';
            break;
        case "500" :
        case "501" :
        case "502" :
        case "503" :
        case "504" :
            $valid_status = _BM_VALIDATION_ERROR;
            if ($my->gid >= $params->validatedetail) { $valid_status .= ' <br />('. mosjbdTools::SafeQuotes($row->validationstatus). ' - ' .mosFormatDate($row->validationdate).' - '.$elapsed->days.' '._BM_DAYS.')'; }
            $valid_img = $mosConfig_live_site.'/components/com_jbd/images/'.'publish_x.png';
            break;
        default :
            $valid_status = _BM_VALIDATION_UNKNOWN_STATUS;
            if ($my->gid >= $params->validatedetail) { $valid_status .= ' <br />('. mosjbdTools::SafeQuotes($row->validationstatus). ' - ' .mosFormatDate($row->validationdate).' - '.$elapsed->days.' '._BM_DAYS.')'; }
            $valid_img = $mosConfig_live_site.'/components/com_jbd/images/'.'publish_r.png';
      }
   }

// -----------------------

   function prepareImageUrl (&$params, &$row, $isSSPic=false) {
     global $mosConfig_live_site;

     $picurl = "";
     if ($row->imageurl) {
        // *** Prepare Image url (compute link)
        if (!(eregi("^http://", $row->imageurl) || (eregi("^https://",$row->imageurl)))) {
           $picurl .= $mosConfig_live_site. '/images/stories/' .$row->imageurl;    // Internal image from Images/Stories
        } else {
           $picurl .= $row->imageurl;                                             // External image (use url)
           if ( eregi($params->urlkey,$picurl) ) {                               // is the URL Keyword present ?
              $picurl = str_replace($params->urlkey, $row->url, $picurl);         // replace the "URL Keyword" with the URL...
           }
           if ($isSSPic) {
              if ( strpos(strtolower($row->imageurl), strtolower(_BM_ADMIN_SNAPSHOTER_URL)) !== false ) {
                 if (isset($params->showsnapshoterpic)) {
                    $params->showsnapshoterpic++;
                 } else {
                    $params->showsnapshoterpic = 1;
                 }
              }
           }
        }
     }
     return $picurl;
   }

// -----------------------

   function isColVisible ($colname, &$columns, $location='') {
      $status = 0;
      if ($columns) {
         foreach ($columns as $column) {
            if ($column->custom) {
               $cname = "f_".$column->name;
            } else {
               $cname = $column->name;
            }
            if ($cname == $colname) {
               $name = 'visible'.$location;
               $status = $column->$name;
            }
         }
      }
      return $status;
   }

// -----------------------

   function displayRating ($name='rating', &$row, &$column, &$params, $link=true, $disp=0, $list='') {
      global $mosConfig_live_site, $my;

      /*
         Display modes: [$disp]
         --------------
         0: display List
         1: rate List
         2: display Detail
         3: rate Detail

         Link: [$link]
         -----
         True:  used as a anchor link (standard)
         False: display - only for Overlib (=> no quotes on tag's parameters to avoid JavaScript conflict)
      */

      $txt = "";
      $namecount = $name."count";
      if ($link) {
         if ( $disp == 1 || $disp == 3) {
            $txt .= '          <form action="';
            if ($disp == 1) {
               $txt .= 'index.php?option=' .$params->_option. '&Itemid=' .$params->_Itemid. '&catid='. $params->_catid .'&navstart=' .$params->navstart. '&mode=' .$params->mode. '&search=' .$params->search;
            } else {
               $txt .= 'index.php?option=' .$params->_option. '&Itemid=' .$params->_Itemid. '&task=detail&catid=' .$params->_catid. '&navstart=' .$params->navstart. '&mode=' .$params->mode. '&id=' .$row->id. '&search=' .$params->search;
            }
            $txt .= '" method="post" name="actionForm">'."\n";
            $txt .= '            <img src="' .$mosConfig_live_site. '/components/com_jbd/images/star' .round($row->$name). '.png" border="0" vspace="2" title="'.$column->title.' : '.$row->$name.' ('.$row->$namecount.' '._BMU_VOTES.')" alt="" /> '."\n";
            if ($params->showratingsplit && $disp != 3 ) { $txt .= "<br />\n"; }
            $txt .= $list;
            if ($params->showratingsplit == 2 && $disp != 3) { $txt .= "<br />\n"; }
            $txt .= '            <input class="button" type="submit" value="' ._BUTTON_VOTE. '" />'."\n";
            $txt .= '            <input type="hidden" name="option" value="' .$params->_option. '" />'."\n";
            if ($disp == 1) {
               $txt .= '            <input type="hidden" name="task" value="vote' .$name. '" />'."\n";     // Vote from List
            } else {
               $txt .= '            <input type="hidden" name="task" value="votd' .$name. '" />'."\n";     // Vote from Detail
            }
            $txt .= '            <input type="hidden" name="Itemid" value="' .$params->_Itemid. '" />'."\n";
            $txt .= '            <input type="hidden" name="catid" value="' .$params->_catid. '" />'."\n";
            $txt .= '            <input type="hidden" name="id" value="' .$row->id. '" />'."\n";
            if ($disp == 3) {
               $txt .= $row->$name.' ('.$row->$namecount.' '._BMU_VOTES.')';
            }
            $txt .= '          </form>'."\n";
         } else if ($disp == 2) {
            $txt .= '            <img src="' .$mosConfig_live_site. '/components/com_jbd/images/star' .round($row->$name). '.png" border="0" vspace="2" title="'.$column->title.' : '.$row->$name.' ('.$row->$namecount.' '._BMU_VOTES.')" alt="" /> '."\n";
            $txt .= $row->$name.' ('.$row->$namecount.' '._BMU_VOTES.')';
         } else {
            $txt .= '            <img src="' .$mosConfig_live_site. '/components/com_jbd/images/star' .round($row->$name). '.png" border="0" vspace="2" title="'.$column->title.' : '.$row->$name.' ('.$row->$namecount.' '._BMU_VOTES.')" alt="" /> '."\n";
         }
      } else {    // Special format for Infobox => No quotes and on 1 line ! (JavaScript requirements)...
         $txt .= '<img src=' .$mosConfig_live_site. '/components/com_jbd/images/star' .round($row->$name). '.png />&nbsp;';
         $txt .= $row->$name.' ('.$row->$namecount.' '._BMU_VOTES.')';
      }

      return $txt;
   }

// -----------------------

   function bm_popup (&$params) {
      echo '<script language="javascript">'."\n";
      echo '  function bm_popup(URL) {'."\n";
      echo '    day = new Date();'."\n";
      echo '    id = day.getTime();'."\n";
      echo '    eval("_BM_B" + id + " = window.open(URL, \'" + id + "\', \'toolbar=0,scrollbars=1,location=0,statusbar=1,menubar=0,resizable=1,width='.$params->bmpopupwidth.',height='.$params->bmpopupheight.'\');");'."\n";
      echo '  }'."\n";
      echo '</script>'."\n";
   }

// -----------------------

   function f_popup (&$params) {
      echo '<script language="javascript">'."\n";
      echo '  function f_popup(URL) {'."\n";
      echo '    day = new Date();'."\n";
      echo '    id = day.getTime();'."\n";
      echo '    eval("_BM_F" + id + " = window.open(URL, \'" + id + "\', \'toolbar=0,scrollbars=1,location=0,statusbar=1,menubar=0,resizable=1,width='.$params->popupwidth.',height='.$params->popupheight.'\');");'."\n";
      echo '  }'."\n";
      echo '</script>'."\n";
   }

// -----------------------

   function displayCustom ($name='rating', &$row, &$column, &$params, $link=true, $disp=0, $list='') {
      global $mosConfig_live_site, $my;

      $txt = '';
//      $txt .= "[$column->f_type:$name] ";
      switch ($column->f_type) {
        case "3" :  // INT
            $txt .= number_format($row->$name, 0, _BMU_FMT_DECIMAL, _BMU_FMT_THOUSAND);
            break;
        case "4" :  // TINYINT
            $txt .= ($row->$name) ? _BM_YES : _BM_NO;
            break;
        case "5" :  // DATE
            $txt .= mosFormatDate($row->$name);
            break;
        case "6" :  // URL
            if ($link) {
               if ($row->$name) {   // Is there an URL to display ?
//                  $pic = $mosConfig_live_site.'/components/com_jbd/images/url.png';
                  $pic = $mosConfig_live_site.'/images/M_images/weblink.png';
                  $txt .= '<a href="'. $row->$name. '" target="_blank">';
                  $txt .= '<img src="' .$pic. '" border="0" title="'.$column->title.' : ' .$row->$name. '" alt="'.$column->title.'" />';
                  $txt .= '</a>';
               } else {
                  $txt .= '&nbsp;';
               }
            } else {
               $txt .= $row->$name;
            }
            break;
        case "7" :  // MAIL
            if ($link) {
               if ($row->$name) {   // Is there an address to display ?
//                  $pic = $mosConfig_live_site.'/components/com_jbd/images/mail.png';
                  $pic = $mosConfig_live_site.'/images/M_images/emailButton.png';
                  $txt .= '<a href="mailto:'. $row->$name. '" title="'.$column->title.' : ' .$row->$name. '" target="_blank">';
                  $txt .= '<img src="' .$pic. '" border="0" alt="'.$column->title.'" />';
                  $txt .= '</a>';
               } else {
                  $txt .= '&nbsp;';
               }
            } else {
               $txt .= $row->$name;
            }
            break;
        case "8" :  // RATE
            $txt .= mosjbdTools::displayRating ($name, $row, $column, $params, $link, $disp, $list);
            break;
        case "9" :  // POPUP Button
            if ($link) {
               if ($row->$name) {   // Is there an URL to display ?
//                  $pic = $mosConfig_live_site.'/components/com_jbd/images/popup.png';
                  $pic = $mosConfig_live_site.'/images/M_images/weblink.png';
                  switch ($params->popuptype) {
                    case "1" :   // Mode : Button
                        $txt .= '<form>';
                        $txt .= '<input type="button" value="'._BM_POPUP_TITLE.'" onclick="javascript:f_popup(\''.$row->$name.'\');" title="'.$column->title.' : '._BM_POPUP_TITLE.' => '.$row->$name.'">';
                        $txt .= '</form>';
                        break;
                    case "0" :   // Mode : URL
                    default :    // Other value => default
                        $txt .= '<a href="javascript:f_popup(\''.$row->$name.'\');" title="'.$column->title.' : '._BM_POPUP_TITLE.' => '.$row->$name.'">';
                        $txt .= '<img src="' .$pic. '" border="0" alt="'.$column->title.'" />';
                        $txt .= '</a>';
                  }
               } else {
                  $txt .= '&nbsp;';
               }
            } else {
               $txt .= $row->$name;
            }
            break;
        default :   // OTHERS (incl. TEXT and VARCHAR)
            $txt .= $row->$name;
      }
//     $txt .= '';

     return $txt;
   }

// -----------------------

   // *** Overlib initialisation - Check if DIV "overDiv" is not present and load library, otherwise skip it to avoid duplicate routine initialisation (IE6 issue !!)
   function overlibInitCallBM () {
     global $mosConfig_live_site;

     static $overlibInitCalled = 0;  // use static variable to keep status for next call to the function to avoid multiple reloading !
     if (!$overlibInitCalled) {
        $txt = "\n";
        $txt .= "<!-- jbd Overlib -->\n";
        $txt .= '<script language="javascript" type="text/javascript">'."\n";
        $txt .= "if ( !document.getElementById('overDiv') ) {  "."\n";
        $txt .= "   document.writeln('<di'+'v id=\"overDiv\" style=\"position:absolute; visibility:hidden; z-index:10000;\"><\/d'+'iv>');"."\n";
        $txt .= "   document.writeln('<scr'+'ipt language=\"Javascript\" type=\"text/javascript\" src=\"" .$mosConfig_live_site. "/includes/js/overlib_mini.js\"><\/scr'+'ipt>');"."\n";
        $txt .= "} "."\n";
        $txt .= "</script>"."\n";
        $overlibInitCalled++;
     } else {
        $txt = "";
     }
     return $txt;
   }

// -----------------------

   function prepareOverlibBox (&$params, &$row, $showurldetails, $picurl, $valid_status, $valid_img) {
     global $mosConfig_live_site;
     // *** Prepare Overlib box
     if ($showurldetails == 1 || $showurldetails == 2) {
        $overlibtxt = ' onmouseover="return overlib(\'<table border=0 cellspacing=0 cellpadding=2>';     // Overlib : Init command
        if (mosjbdTools::isColVisible('business', $params->columns, 'infobox') && $row->url)  {
           $overlibtxt .= '<tr><td valign=top><b>'._BMU_URL.'&nbsp;:&nbsp;</b></td><td>' . htmlspecialchars(mosjbdTools::URLMaxSize($row->url,$params->urlmaxsize), ENT_NOQUOTES). '&nbsp;';

           if ($row->ratingadmin) {
              if ($row->ratingadmin == 1) { // Bronze
                 $overlibtxt .= '<img src=' .$mosConfig_live_site. '/components/com_jbd/images/isbronze.png border=0 alt=\\\'' ._BMU_ISBRONZE. '\\\' />&nbsp;';
              } else {  // Gold
                 $overlibtxt .= '<img src=' .$mosConfig_live_site. '/components/com_jbd/images/isgold.png border=0 alt=\\\'' ._BMU_ISGOLD. '\\\' />&nbsp;';
              }
           }

           if ($params->showpoplast) {
              $created = mosjbdTools::calcElapsedDays( $row->created );
              if ($created->days <= $params->showpoplast) {
                 $overlibtxt .= '<img src=' .$mosConfig_live_site. '/components/com_jbd/images/isnew.png border=0 alt=\\\'' ._BMU_ISNEW. '\\\' />&nbsp;';
              }
           }

           if ($params->showpoptop && $params->canvote) {
              if ($row->rating >= $params->showpoptop) {
                 $overlibtxt .= '<img src=' .$mosConfig_live_site. '/components/com_jbd/images/istop.png border=0 alt=\\\'' ._BMU_ISTOP. '\\\' />&nbsp;';
              }
           }

           if ($params->showpopbest) {
              if ($row->hits >= $params->showpopbest) {
                 $overlibtxt .= '<img src=' .$mosConfig_live_site. '/components/com_jbd/images/isbest.png border=0 alt=\\\'' ._BMU_ISBEST. '\\\' />&nbsp;';
              }
           }
           $overlibtxt .= '</td></tr>';
        }
        if (mosjbdTools::isColVisible('image', $params->columns, 'infobox') && $row->imageurl) {
           $overlibtxt .= '<tr><td valign=top><b>'._BMU_IMAGE.'&nbsp;:&nbsp;</b></td><td><img src=\\\'' .$picurl. '\\\'';
           if ($params->imgforceinfoboxwidth) {
              $overlibtxt .= ' width=' .$params->imgforceinfoboxwidth;    // To force the image size...
           }
           if ($params->imgforceinfoboxheight) {
              $overlibtxt .= ' height=' .$params->imgforceinfoboxheight;    // To force the image size...
           }
           $overlibtxt .= ' border=0 align=left hspace=2 alt=\\\'\\\' /></td></tr>';
        }
//        if (mosjbdTools::isColVisible('description', $params->columns, 'infobox') && trim(strip_tags($row->description))) { $overlibtxt .= '<tr><td valign=top><b>'._BMU_SHORT_DESCRIPTION.'&nbsp;:&nbsp;</b></td><td>' .htmlspecialchars(mosjbdTools::SafeQuotes($row->description, ENT_NOQUOTES)). '</td></tr>'; }
        if (mosjbdTools::isColVisible('description', $params->columns, 'infobox') && trim(strip_tags($row->description))) { $overlibtxt .= '<tr><td valign=top><b>'._BMU_SHORT_DESCRIPTION.'&nbsp;:&nbsp;</b></td><td>' .mosjbdTools::SafeQuotes($row->description, ENT_NOQUOTES). '</td></tr>'; }
        if ($showurldetails == 2) {
           if (mosjbdTools::isColVisible('category', $params->columns, 'infobox')) {
              $overlibtxt .= '<tr><td valign=top><b>'._BMU_CAT.'&nbsp;:&nbsp;</b></td><td>';
              $overlibtxt .= '<ul>';
              foreach ($row->categories as $catn) {
                 $overlibtxt .=  '<li>'.mosjbdTools::SafeQuotes(htmlspecialchars($catn, ENT_NOQUOTES))."</li>";
              }
              $overlibtxt .= '</ul>';
              $overlibtxt .=  '</td></tr>';
           }
           if (mosjbdTools::isColVisible('rating', $params->columns, 'infobox') && $params->canvote)    { $overlibtxt .= '<tr valign=top><td><b>'._BMU_RATING.'&nbsp;:&nbsp;</b></td><td><img src=' .$mosConfig_live_site. '/components/com_jbd/images/star' .round($row->rating). '.png />&nbsp;' .$row->rating. ' ('.$row->ratingcount.' '._BMU_VOTES.')</td></tr>';}
           if (mosjbdTools::isColVisible('hits', $params->columns, 'infobox'))      { $overlibtxt .= '<tr valign=top><td><b>'._BMU_HITS.'&nbsp;:&nbsp;</b></td><td>' .mosjbdTools::SafeQuotes(number_format($row->hits, 0, _BMU_FMT_DECIMAL, _BMU_FMT_THOUSAND)). '</td></tr>'; }
           if (mosjbdTools::isColVisible('created', $params->columns, 'infobox'))      { $overlibtxt .= '<tr valign=top><td><b>'._BMU_DATE.'&nbsp;:&nbsp;</b></td><td>' .mosFormatDate($row->created). ' / '.mosFormatDate($row->modified).'</td></tr>'; }
           if (mosjbdTools::isColVisible('created_by', $params->columns, 'infobox')) {
                                         $overlibtxt .= '<tr valign=top><td><b>'._BMU_PUBLISHER.'&nbsp;:&nbsp;</b></td><td>' .mosjbdTools::SafeQuotes($row->username);
                                         if ( $row->private && ( $params->markprivate == 1 || $params->markprivate == 3 ) && $params->allowprivate) {
                                            $overlibtxt .= '&nbsp;<span style=\\\'color: Red; font-weight: bold;\\\'>'._BMU_PRIVATE_MARK.'</span>';
                                         }
                                         $overlibtxt .= '</td></tr>';
                                       }
           // Custom fields
           foreach ($params->columns as $column) {
             if ($column->custom) {
                $name = 'f_'.$column->name;
                if (mosjbdTools::isColVisible($name, $params->columns, 'infobox')) {
                   if ( ($row->$name && $column->f_type != 8) || ($params->canvote && $column->f_type == 8) || $column->f_type == 4 ) {
                      $overlibtxt .= '<tr valign=top><td><b>'.$column->title.'&nbsp;:&nbsp;</b></td><td>' .mosjbdTools::SafeQuotes(mosjbdTools::displayCustom($name, $row, $column, $params, false)).'</td></tr>';}
                   }
             }
           }

           if ( $row->url && ($params->markvalidate == 1 || $params->markvalidate == 3 ) ) { $overlibtxt .= '<tr><td valign=top><b>'._BMU_VALIDATION.'&nbsp;:&nbsp;</b></td><td><img src=\\\'' .$valid_img. '\\\' border=0 alt=\\\'\\\' />&nbsp;' .mosjbdTools::SafeQuotes($valid_status).'</td></tr>'; }

        }

        $overlibtxt .= '</table>\'';
        if ($params->showcaption) {
           $overlibtxt .= ', CAPTION, \''.mosjbdTools::SafeQuotes(htmlspecialchars($row->title, ENT_NOQUOTES)).'\'';  // Overlib : Display Caption (Box title)
        }
        $overlibtxt .= ', VAUTO, HAUTO';                                                                                // Overlib : To keep the box within the Browser page
        $overlibtxt .= ($params->overlibcfg != "") ? ", ".$params->overlibcfg : "";                                     // Overlib : Apply custom parameters like : [WIDTH, 400, FGCOLOR, 'Black', BGCOLOR, '#FFFFFF']
        $overlibtxt .= ');" onmouseout="return nd();"';
     } else {
        $overlibtxt = ' title="';
        if ($showurldetails == 3) {
           if (mosjbdTools::isColVisible('business', $params->columns, 'infobox') && $row->url) { $overlibtxt .= 'URL: ' . mosjbdTools::URLMaxSize($row->url,$params->urlmaxsize) ; }
           if ( (mosjbdTools::isColVisible('business', $params->columns, 'infobox') && $row->url) && (mosjbdTools::isColVisible('description', $params->columns, 'infobox') && trim(strip_tags($row->description))) ) { $overlibtxt .= ' | '; }
           if (mosjbdTools::isColVisible('description', $params->columns, 'infobox') && trim(strip_tags($row->description))) { $overlibtxt .= 'Desc: ' .mosjbdTools::SafeQuotes( mosjbdTools::remove_tags($row->description, false) ); }
        }
        $overlibtxt .= '"';
     }
     return $overlibtxt;
   }

// -----------------------

   function getPref($userid, $category, $name, $val = '') {
      global $database;

       $database->setQuery( "SELECT value"
                      . "\n  FROM #__jbd_prefs "
                      . "\n WHERE userid = '$userid' AND category = '$category' AND name = '$name'"
       );

       $database->loadObject($row);

       if ( $row ) {
           return $row->value;
       } else {
         return $val;
       }
   }

// -----------------------

   function getPrefs($userid, $category, &$params) {
      global $database;

       $database->setQuery( "SELECT name, value"
                       . "\n FROM #__jbd_prefs "
                       . "\n WHERE userid = '$userid' AND category = '$category'"
                       . "\n ORDER BY name"
       );

       $rows = $database->loadObjectList();

       for ($i=0; $i<count($rows); $i++) {    // Convert Object
         $o = $rows[$i]->name;
         $params->$o = $rows[$i]->value;
       }

       return $params;
   }

// -----------------------

   function setPref($userid, $category, $name, $value ) {
      global $database;

       // verify if the param already exists
       $database->setQuery( "SELECT count(name) AS nb"
       . "\n FROM #__jbd_prefs"
       . "\n WHERE userid = '$userid' AND category = \"$category\" AND name = \"$name\""
       );

       $database->loadObject($row);

       if ( $row->nb > 0 ) {  // Exists => Edit
           $database->setQuery( "UPDATE #__jbd_prefs SET value='$value' WHERE userid = '$userid' AND category = \"$category\" AND name = \"$name\"");

           if (!$database->query()) {
              return $database->getErrorMsg();
         }
       } else {               // Not present => Add
           $database->setQuery( "INSERT INTO #__jbd_prefs (userid, category, name, value) VALUES ('$userid', '$category', '$name', '$value')");

           if (!$database->query()) {
              return $database->getErrorMsg();
         }
       }
   }

// -----------------------

   function setPrefs($userid, $category, &$params) {

     foreach ($params as $name=>$value) {
       mosjbdTools::setPref($userid, $category, $name, $value);
     }

   }

// -----------------------

   function delPref($userid, $category, $name ) {
      global $database;

      $database->setQuery( "DELETE FROM #__jbd_prefs WHERE userid = '$userid' AND category = \"$category\" AND name = \"$name\"");

      if (!$database->query()) {
         return $database->getErrorMsg();
      }

   }

// -----------------------

   function defaultValue (&$param, $val='') {
       if ( !isset($param) ) {
          $param = $val;
       }
   }

// -----------------------

    function getColumnTitle ($name, &$row) {
      if (!$row->custom) {
         switch ($name) {
           case "icon" :
               $row->title = _BM_ICON;
               break;
           case "business" :
               $row->title = _BMU_jbd;
               break;
           case "description" :
               $row->title = _BMU_DESCRIPTION;
               break;
           case "detail" :
               $row->title = _BMU_DETAIL;
               break;
           case "category" :
               $row->title = _BMU_CAT;
               break;
           case "image" :
               $row->title = _BMU_IMAGE;
               break;
           case "rating" :
               $row->title = _BMU_RATING;
               break;
           case "hits" :
               $row->title = _BMU_HITS;
               break;
           case "created" :
               $row->title = _BMU_DATE;
               break;
           case "created_by" :
               $row->title = _BMU_PUBLISHER;
               break;
           case "keywords" :
               $row->title = _BMU_KEYWORDS;
               break;
           default :
               $row->title = "-Unknown-";
         }
      }
    }

// -----------------------

   function LoadjbdParams (&$params) {
     global $database;

       // Load Config fields
       mosjbdTools::getPrefs(-1, 'params', $params);  // To load all params in only one query... But do not provide of default values if a param is not present...

       // Check for Default values
       mosjbdTools::defaultValue($params->catsort, '0');
       mosjbdTools::defaultValue($params->bmsort, '0');
       mosjbdTools::defaultValue($params->displaymode, '0');
       mosjbdTools::defaultValue($params->showdisplaymode, '1');
       mosjbdTools::defaultValue($params->showalphaindex, '1');
       mosjbdTools::defaultValue($params->alphaindexsep1, '');
       mosjbdTools::defaultValue($params->alphaindexsep2, '');
       mosjbdTools::defaultValue($params->defaultsearch, '*');
       mosjbdTools::defaultValue($params->showsearchbox, '1');
       mosjbdTools::defaultValue($params->showheader, '1');
       mosjbdTools::defaultValue($params->showheadersort, '1');
       mosjbdTools::defaultValue($params->showalternate, '1');
       mosjbdTools::defaultValue($params->nbcolumns, '1');
       mosjbdTools::defaultValue($params->showurldetails, '2');
       mosjbdTools::defaultValue($params->showratingsplit, '0');
       mosjbdTools::defaultValue($params->catpos, '1');
       mosjbdTools::defaultValue($params->catshowcount, '1');
       mosjbdTools::defaultValue($params->catnbcolumns, '3');
       mosjbdTools::defaultValue($params->catdisplayorder, '0');
       mosjbdTools::defaultValue($params->subcatsdisplay, '0');
       mosjbdTools::defaultValue($params->subcatsorder, '0');
       mosjbdTools::defaultValue($params->showemptycats, '0');
       mosjbdTools::defaultValue($params->cansubmit, '1');
       mosjbdTools::defaultValue($params->submitlevel, '1');
       mosjbdTools::defaultValue($params->submitpos, '1');
       mosjbdTools::defaultValue($params->submitauto, '0');
       mosjbdTools::defaultValue($params->submitautolevel, '1');
       mosjbdTools::defaultValue($params->canvote, '1');
       mosjbdTools::defaultValue($params->votelevel, '0');
       mosjbdTools::defaultValue($params->overlibcfg, '');
       mosjbdTools::defaultValue($params->urlkey, '##URL_HERE##');
       mosjbdTools::defaultValue($params->urlautocheck, '7');
       mosjbdTools::defaultValue($params->hitdetail, '0');
       mosjbdTools::defaultValue($params->protocols, _BM_PROTOCOLS);
       mosjbdTools::defaultValue($params->detailshowtitles, 0);
       mosjbdTools::defaultValue($params->allowprivate, '1');
       mosjbdTools::defaultValue($params->markprivate, '1');
       mosjbdTools::defaultValue($params->directurl, '0');
       mosjbdTools::defaultValue($params->showdescsplit, '0');
       mosjbdTools::defaultValue($params->shownoitem, '1');
       mosjbdTools::defaultValue($params->showimagesplit, '0');
       mosjbdTools::defaultValue($params->navperpage, '50');
       mosjbdTools::defaultValue($params->navigatorpos, '3');
       mosjbdTools::defaultValue($params->displaycopyrights, '1');
       mosjbdTools::defaultValue($params->defaultimage, '1');
       mosjbdTools::defaultValue($params->allowdetail, '1');
       mosjbdTools::defaultValue($params->submitnotify, '1');
       mosjbdTools::defaultValue($params->comheaderlist, '');
       mosjbdTools::defaultValue($params->comheaderdetail, '');
       mosjbdTools::defaultValue($params->descfulledit, '1');
       mosjbdTools::defaultValue($params->detailshowpagetitle, '1');
       mosjbdTools::defaultValue($params->searchboxsize, '10');
       mosjbdTools::defaultValue($params->markvalidate, '1');
       mosjbdTools::defaultValue($params->submitcat, '0');
       mosjbdTools::defaultValue($params->urlmaxsize, '75');
       mosjbdTools::defaultValue($params->descboxwidth, '40');
       mosjbdTools::defaultValue($params->descboxheight, '10');
       mosjbdTools::defaultValue($params->dynamictitlerevorder, '0');
       mosjbdTools::defaultValue($params->showdetaillink, '1');
       mosjbdTools::defaultValue($params->allow_getmeta, '1');
       mosjbdTools::defaultValue($params->showcatdesc, '1');
       mosjbdTools::defaultValue($params->showcatdescpos, '0');
       mosjbdTools::defaultValue($params->comheadersubmit, '');
       mosjbdTools::defaultValue($params->regcaneditown, '0');
       mosjbdTools::defaultValue($params->validatesubmit, '1');
       mosjbdTools::defaultValue($params->validatefront, '1');
       mosjbdTools::defaultValue($params->validatestatus, '0');
       mosjbdTools::defaultValue($params->trackusers, '0');
       mosjbdTools::defaultValue($params->hitsdelay, '0');
       mosjbdTools::defaultValue($params->showseparator, '0');
       mosjbdTools::defaultValue($params->validatedetail, '1');
       mosjbdTools::defaultValue($params->checkemptyurl, '0');
       mosjbdTools::defaultValue($params->forcesubmitlink, '0');
       mosjbdTools::defaultValue($params->allowdate, '0');
       mosjbdTools::defaultValue($params->botsonbmdesc, '1');
       mosjbdTools::defaultValue($params->showpoplast, '7');
       mosjbdTools::defaultValue($params->showpoptop, '4.75');
       mosjbdTools::defaultValue($params->showpopbest, '500');
       mosjbdTools::defaultValue($params->forceprivate, '0');
       mosjbdTools::defaultValue($params->showpathway, '1');
       mosjbdTools::defaultValue($params->showcats, '1');
       mosjbdTools::defaultValue($params->forceaddcat, '0');
       mosjbdTools::defaultValue($params->desceditwidth, '500');
       mosjbdTools::defaultValue($params->desceditheight, '200');
       mosjbdTools::defaultValue($params->forceredirect, '0');
       mosjbdTools::defaultValue($params->adminratesort, '0');
       mosjbdTools::defaultValue($params->canvotedetail, '1');
       mosjbdTools::defaultValue($params->canrecommend, '1');
       mosjbdTools::defaultValue($params->wrapperwidth, '100%');
       mosjbdTools::defaultValue($params->wrapperheight, '600');
       mosjbdTools::defaultValue($params->comheaderwrapper, '');
       mosjbdTools::defaultValue($params->detailfulledit, '1');
       mosjbdTools::defaultValue($params->showcaption, '1');
       mosjbdTools::defaultValue($params->csscategories, 'category');
       mosjbdTools::defaultValue($params->csscategoriessel, 'sectiontableheader');
       mosjbdTools::defaultValue($params->csssubcategories, 'subcategory');
       mosjbdTools::defaultValue($params->cssjbd, 'category');
       mosjbdTools::defaultValue($params->cssdisplaymode, '');
       mosjbdTools::defaultValue($params->cssdisplaymodesel, 'sectiontableheader');
       mosjbdTools::defaultValue($params->cssalphaindex, '');
       mosjbdTools::defaultValue($params->cssalphaindexsel, 'sectiontableheader');
       mosjbdTools::defaultValue($params->csspathway, 'category');
       mosjbdTools::defaultValue($params->csstableheader, 'sectiontableheader');
       mosjbdTools::defaultValue($params->csscategoryheader, 'componentheading');
       mosjbdTools::defaultValue($params->allowdesc, '1');
       mosjbdTools::defaultValue($params->catlistmode, '0');
       mosjbdTools::defaultValue($params->showcaticon, '1');
       mosjbdTools::defaultValue($params->emptyurlnolink, '0');
       mosjbdTools::defaultValue($params->botsonbmdetail, '1');
       mosjbdTools::defaultValue($params->botsonheaderlist, '1');
       mosjbdTools::defaultValue($params->botsonheaderdetail, '1');
       mosjbdTools::defaultValue($params->botsonheaderwrapper, '1');
       mosjbdTools::defaultValue($params->botsonheadersubmit, '1');
       mosjbdTools::defaultValue($params->urlautochecktimeout, '15');
       mosjbdTools::defaultValue($params->searchforceopen, '0');
       mosjbdTools::defaultValue($params->shownavresults, '1');
       mosjbdTools::defaultValue($params->showpagetitle, '1');
       mosjbdTools::defaultValue($params->shownoitemtitle, '1');
       mosjbdTools::defaultValue($params->checkduplicateurl, '1');
       mosjbdTools::defaultValue($params->mosredirect, '1');
       mosjbdTools::defaultValue($params->paddingheader, '2');
       mosjbdTools::defaultValue($params->paddingcolumns, '1');
       mosjbdTools::defaultValue($params->cancredit, '0');
       mosjbdTools::defaultValue($params->showcatlistdesc, '0');
       mosjbdTools::defaultValue($params->paddingcategories, '0');
       mosjbdTools::defaultValue($params->botsoncatdesc, '1');
       mosjbdTools::defaultValue($params->botsoncatlistdesc, '1');
       mosjbdTools::defaultValue($params->nomorecredits, '0');
       mosjbdTools::defaultValue($params->cssjbdgold, 'category');
       mosjbdTools::defaultValue($params->cssjbdbronze, 'category');
       mosjbdTools::defaultValue($params->reducerating, '-1');
       mosjbdTools::defaultValue($params->showcattitle, '1');
       mosjbdTools::defaultValue($params->imgforcewidth, '0');
       mosjbdTools::defaultValue($params->imgforceheight, '0');
       mosjbdTools::defaultValue($params->imgadminpreview, '1');
       mosjbdTools::defaultValue($params->imgforcedetailwidth, '0');
       mosjbdTools::defaultValue($params->imgforcedetailheight, '0');
       mosjbdTools::defaultValue($params->imgforceinfoboxwidth, '0');
       mosjbdTools::defaultValue($params->imgforceinfoboxheight, '0');
       mosjbdTools::defaultValue($params->detailadswidth, '150');
       mosjbdTools::defaultValue($params->detailads, '');
       mosjbdTools::defaultValue($params->cssdetailads, '');
       mosjbdTools::defaultValue($params->botsondetailads, '1');
       mosjbdTools::defaultValue($params->popupwidth, '300');
       mosjbdTools::defaultValue($params->popupheight, '300');
       mosjbdTools::defaultValue($params->popuptype, '0');
       mosjbdTools::defaultValue($params->bmpopupwidth, '300');
       mosjbdTools::defaultValue($params->bmpopupheight, '300');
       mosjbdTools::defaultValue($params->validationdebug, '0');
       mosjbdTools::defaultValue($params->checkduplicatetitle, '1');
       mosjbdTools::defaultValue($params->submitnewmetatag, '1');

       // *** Check if Root Cat is present (ID="-1") !
       $database->setQuery( "SELECT c.id, c.parent"
                       . "\n FROM #__jbd_categories as c"
                       . "\n WHERE c.id = -1"
       );
       $database->loadObject($row);

       if ( !$row ) {  // Error : Root Cat must be present (ID = "-1")
          mosjbdTools::initRootCat();      // RootCat NOT present => create it
       } else {
           if ($row->parent != '-2') {  // Error : Root Cat must be ID="-1" and Parent="-2" !!!
              $database->setQuery( "UPDATE #__jbd_categories SET parent = -2 WHERE id = -1");
              if (!$database->query()) {
                  echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.location='index2.php?option=$option&task=showcats';</script>\n";
                  exit;
              }
           }
       }

       // *** Check System Columns - Verify that default fields are present
       $database->setQuery( "SELECT *"
                       . "\n FROM #__jbd_columns"
                       . "\n WHERE category=''"
                       . "\n AND custom='0'"
       );
       $cols = $database->loadObjectList();

       if ( count($cols) < 11 ) {  // check if table is empty or missing fields
          mosjbdTools::initColumns( $cols );      // => populate table with default
       }

       // *** Load Columns to Params
       $database->setQuery( "SELECT *"
                       . "\n FROM #__jbd_columns"
                       . "\n WHERE category=''"
                       . "\n ORDER BY ordering"
       );
       $rows = $database->loadObjectList();

       // *** Fill default fields with the name from the Language file
       for ($i=0; $i<count($rows); $i++) {
         $row = &$rows[$i];
         mosjbdTools::getColumnTitle($row->name, $row);
       }
       $params->columns = $rows;

       // *** Check Admin Columns - Verify that default fields are present
       $database->setQuery( "SELECT *"
                       . "\n FROM #__jbd_columns"
                       . "\n WHERE category='admin'"
       );
       $adminCols = $database->loadObjectList();

       if ( count($adminCols) < 19 ) {  // check if table is empty or missing fields
          mosjbdTools::initAdminColumns( $adminCols );      // => Populate table with default
       }

       // *** Load Admin Columns
       $database->setQuery( "SELECT *"
                       . "\n FROM #__jbd_columns"
                       . "\n WHERE category='admin'"
                       . "\n ORDER BY ordering"
       );
       $rows = $database->loadObjectList();

       // *** Add Admin columns order to params
       $params->admincolumns = $rows;

   }

// -----------------------

   function checkdnsrr_winNT( $host, $type = '' ) {

   // *** the "checkdnsrr" is not implemented under Windows... Special DNS check using "NSLookup" through Exec command...

      $dnsStatus = false;

      if( !empty( $host ) ) {
          # Set Default Type:
          if ( $type == '' ) $type = "MX";
          $typecmd = "-type=$type";
          @exec( "nslookup $typecmd $host", $output );
          foreach ($output as $k=>$line) {
   //           echo "DNS: $k : <b>".$line."</b><br />\n";
              # Valid records begin with host name:
              if ( eregi( "^$host", $line ) || eregi( ".*:?$host", $line) ) {
   //              echo "<b>YES</b> : $host == $line<br />\n";
                 # record found:
                 $dnsStatus = true;
                 break;
              } elseif ( eregi( ".*timed out", $line) ) {
                 $dnsStatus = false;
                 break;
              }
          }
      }
      return $dnsStatus;
   }

// -----------------------

   function get_url_title($url, $info=true, $timeout=7, $debug=false) {

      $urlArray = parse_url($url);
      if (!in_array($urlArray['scheme'],array('','http'))) {
          return;
      }
      $urlArray['port'] = isset($urlArray['port']) ? $urlArray['port'] : 80;
      $urlArray['path'] = isset($urlArray['path']) ? $urlArray['path'] : '/';

      if ($debug) {
         $fp = fsockopen ($urlArray['host'], ($urlArray['port'] ? $urlArray['port'] : 80), $errno, $errstr, $timeout);
      } else {
         $fp = @fsockopen ($urlArray['host'], ($urlArray['port'] ? $urlArray['port'] : 80), $errno, $errstr, $timeout);
      }
      if (!$fp) {
         echo "Socket Error : $errstr ($errno)<br>\n";
         return;
      } else {

         $useragent = "Mozilla/5.0 (compatible; MOSjbd/".mosjbd::getVersion(false)."; Link Checker)";   // Fake a Mozilla browser for certain IIS websites...
         $dump  = "GET " .$urlArray['path']. " HTTP/1.1\r\n";  // Some web servers do not allow method HEAD, but GET or TRACE
         $dump .= "User-Agent: ".$useragent."\r\n";
         $dump .= "Host: " .$urlArray['host']. "\r\n";
         $dump .= "Connection: close\r\n\r\n";

         if ($debug) {
/*
            foreach ($urlArray as $k=>$v) {
              echo '<span style="color: Red; font-weight: bold;">'."DEBUG</span>: $k: $v<br />\n";
            }
*/
            echo '   <textarea cols="120" rows="6">';
            echo $dump;
            echo '</textarea><br />'."\n";
         }

         if ($debug) {
             fputs ($fp, $dump);
         } else {
             @fputs ($fp, $dump);
         }

         $d = '';
         while (!feof($fp)) {
            if ($debug) {
                $d .= fgets ($fp,1024);
            } else {
                $d .= @fgets ($fp,1024);
            }

            if (preg_match('~(</head>|<body>|(<title>\s*(.*?)\s*</title>))~i', $d, $m)) {
               break;
            }
         }

         if ($debug) {
            echo '   <textarea cols="120" rows="12">';
            echo $d;
            echo '</textarea><br />'."\n";
         }

         @fclose ($fp);
         return (isset($m[3])) ? $m[3] : "";
      }
   }

// -----------------------

   function get_meta_tags2($url, $info=true, $timeout=7, $debug=false) {

      $meta = array();
      $urlArray = parse_url($url);
      if (!in_array($urlArray['scheme'],array('','http'))) {
          return;
      }
      $urlArray['port'] = isset($urlArray['port']) ? $urlArray['port'] : 80;
      $urlArray['path'] = isset($urlArray['path']) ? $urlArray['path'] : '/';

      if ($debug) {
         $fp = fsockopen ($urlArray['host'], ($urlArray['port'] ? $urlArray['port'] : 80), $errno, $errstr, $timeout);
      } else {
         $fp = @fsockopen ($urlArray['host'], ($urlArray['port'] ? $urlArray['port'] : 80), $errno, $errstr, $timeout);
      }
      if (!$fp) {
         echo "Socket Error : $errstr ($errno)<br>\n";
         return;
      } else {

         $useragent = "Mozilla/5.0 (compatible; MOSjbd/".mosjbd::getVersion(false)."; Link Checker)";   // Fake a Mozilla browser for certain IIS websites...
         $dump  = "GET " .$urlArray['path']. " HTTP/1.1\r\n";  // Some web servers do not allow method HEAD, but GET or TRACE
         $dump .= "User-Agent: ".$useragent."\r\n";
         $dump .= "Host: " .$urlArray['host']. "\r\n";
         $dump .= "Connection: close\r\n\r\n";

         if ($info && $debug) {
/*
            foreach ($urlArray as $k=>$v) {
              echo '<span style="color: Red; font-weight: bold;">'."DEBUG</span>: $k: $v<br />\n";
            }
*/
            echo '   <textarea cols="120" rows="6">';
            echo $dump;
            echo '</textarea><br />'."\n";
         }

         if ($debug) {
             fputs ($fp, $dump);
         } else {
             @fputs ($fp, $dump);
         }

         $d = '';
         $str= '';
         $i = 0;

         while (!feof($fp)) {

            if ($debug) {
                $str = fgets ($fp,1024);
            } else {
                $str = @fgets ($fp,1024);
            }
            $d .= $str;
            if (preg_match('~(</head>|<body>)~i', $d, $m)) {    // Retrieve only the HEAD section
               break;
            }
         }

         if ($info && $debug) {
            echo '<textarea cols="120" rows="7">';
            echo $d;
            echo '</textarea><br />'."\n";
         }

         // Looking for : <meta name="description" content="text" />
         // or this way : <meta content="text" name="description" />

         preg_match_all("/<meta \s*(.*?)\s*(\/>|>)/i", $d, $m, PREG_SET_ORDER);  // Grab All meta tags

         foreach ($m as $r=>$s) {                                                // Extract tag name & content
            preg_match('~name="(\s*(.*?)\s*)"~i', $s[1], $n);
            if (isset($n[1])) {
              $name = strtolower ($n[1]);
              preg_match('~content="(\s*(.*?)\s*)"~i', $s[1], $c);
              $meta[$name] = $c[1];
            }
         }

         if ($info && $debug) {
            echo 'DEBUG: <b>Meta tags</b> :<br /><textarea cols="120" rows="12">';
            foreach ($meta as $k=>$v) {
              echo "$k => $v\n";
            }
            echo '</textarea><br />'."\n";
         }

         @fclose ($fp);
         return $meta;
      }
   }

// -----------------------

   function get_file($url, $timeout=7, $debug=false) {

      // Suppress error reporting so Web site visitors are unaware if the feed fails
   //   error_reporting(0);

/*
      if ($debug) {
         echo 'DEBUG: <a href="' .$url. '">' .$url. '</a><br />'."\n";
      }
*/
      $urlArray = parse_url($url);
      if (!in_array($urlArray['scheme'],array('','http'))) {
         return;
      }
      $urlArray['port'] = isset($urlArray['port']) ? $urlArray['port'] : 80;
      $urlArray['path'] = isset($urlArray['path']) ? $urlArray['path'] : '/';

      if ($debug) {
         $fp = fsockopen ($urlArray['host'], ($urlArray['port'] ? $urlArray['port'] : 80), $errno, $errstr, $timeout);
      } else {
         $fp = @fsockopen ($urlArray['host'], ($urlArray['port'] ? $urlArray['port'] : 80), $errno, $errstr, $timeout);
      }
      if (!$fp) {
         if ($debug) {
            echo "Socket Error : $errstr ($errno)<br>\n";
         }
         return;
      } else {

         $useragent = "Mozilla/5.0 (compatible; MOSjbd/".mosjbd::getVersion(false)."; Link Checker)";   // Fake a Mozilla browser for certain IIS websites...
         $dump  = "GET " .$url. " HTTP/1.1\r\n";
         $dump .= "User-Agent: ".$useragent."\r\n";
         $dump .= "Host: " .$urlArray['host']. "\r\n";
         $dump .= "Connection: close\r\n\r\n";

         if ($debug) {
/*
            foreach ($urlArray as $k=>$v) {
              echo '<span style="color: Red; font-weight: bold;">'."DEBUG</span>: $k: $v<br />\n";
            }
*/
            echo '   <textarea cols="120" rows="6">';
            echo $dump;
            echo '</textarea><br />'."\n";
         }

         if ($debug) {
            fputs ($fp, $dump);
         } else {
            @fputs ($fp, $dump);
         }

         $lines = array();
         while (!feof($fp)) {      // Loop until end of file
            if ($debug) {
               $lines[] = fgets($fp, 1024);
            } else {
               $lines[] = @fgets($fp, 1024);
            }
         }

         @fclose ($fp);
         return $lines;
      }

   }

// -----------------------

   function getHTTP (&$sock, &$urlArray, $HTTPmethod, &$return, $timeout=7, $info=false, $debug=false) {


      $HTTPmethod = strtoupper($HTTPmethod);       // Force UPPERCASE to respect HTTP protocol

      if ($info) { echo 'HTTP method : <b>' .$HTTPmethod. '</b><br />'."\n"; }

      // Clear Status, just in case...
      $return['code'] = '';
      $return['status'] = "";

      $urlquery = (isset($urlArray['query'])) ? "?".$urlArray['query'] : "";

      $useragent = "Mozilla/5.0 (compatible; MOSjbd/".mosjbd::getVersion(false)."; Link Checker)";   // Fake a Mozilla browser for certain IIS websites...
      $dump  = $HTTPmethod. " " .$urlArray['path'].$urlquery. " HTTP/1.1\r\n";  // Some web servers do not allow method HEAD, but GET or TRACE
      $dump .= "User-Agent: ".$useragent."\r\n";
      $dump .= "Host: " .$urlArray['host']. "\r\n";
      $dump .= "Connection: close\r\n\r\n";

      if ($info && $debug) {
/*
         foreach ($urlArray as $k=>$v) {
           echo '<span style="color: Red; font-weight: bold;">'."DEBUG</span>: $k: $v<br />\n";
         }
*/
         echo '   <textarea cols="120" rows="6">';
         echo $dump;
         echo '</textarea><br />'."\n";
      }

      if ($debug) {
         fputs($sock, $dump);
      } else {
         @fputs($sock, $dump);
      }
      if ( phpversion() < "4.3.0" ) {    // is old PHP version prior to 4.3.0 ?
        socket_set_timeout($sock, $timeout);     // Time-Out in secs for "fputs" - Old implementation - depreciated, only for compatibilty !!!
      } else {
        stream_set_timeout($sock, $timeout);     // Time-Out in secs for "fputs" - new implementation since PHP 4.3.0
      }
      $status = socket_get_status($sock);
      $str="-empty-";
      $closed = false;
      $i = 0;

      if ($info && $debug) { echo '   <textarea cols="120" rows="12">'; }

      while( ( !feof($sock) ) && ( !$status['timed_out'] ) && ( $str != "" ) && ( !$closed ) ) {
        if ($debug) {
           $str = fgets($sock, 1024);
        } else {
           $str = @fgets($sock, 1024);
        }
        $status = socket_get_status($sock);

        if ($info) {
           if ($debug) {
              echo $str;
           } else {
              echo "Str [".$i++."] : <b>".$str."</b><br />\n";
           }
        }

        if (eregi("^http/[0-9]+.[0-9]+ ([0-9]{3})", $str) ) {
           $return['code'] = trim(eregi_replace("^http/[0-9]+.[0-9]+ ([0-9]{3}) [a-z ]*", "\\1", $str));
           if ( substr(strtoupper($return['code']),0,4) == 'HTTP') {  // Code starts with "HTTP" => there is only HTTP code without description.
              $return['code'] = trim(eregi_replace("^http/[0-9]+.[0-9]+ ([0-9]{3})[a-z ]*", "\\1", $str));
           }
           $return['code'] = substr($return['code'],0,3);    // Keep only the first 3 digit...
           $return['status'] = $str;                         // Full status code (code & description)
        }
        if (eregi("^Content-Type: ", $str))   {
           $return['contentType'] = trim(eregi_replace("^Content-Type: ", "", $str));
        }
        if (eregi("^User-Agent: ", $str))   {
           $return['userAgent'] = trim(eregi_replace("^User-Agent: ", "", $str));
        }
        if (eregi("^Location: ", $str))   {
           $return['location'] = trim(eregi_replace("^Location: ", "", $str));
        }
        if (eregi("^Content-Length: ", $str))   {
           $return['contentLength'] = trim(eregi_replace("^Content-Length: ", "", $str));
        }
        $closed = ( $HTTPmethod == "GET" && ( $str == "\r\n" && ($return['code']=="200" || $return['code']=="404")) );
      }

      if ($info && $debug) { echo '</textarea><br />'."\n"; }

      if ($info && $status['timed_out'] == 1) {
         echo '<span style="color: Red; font-weight: bold;">'."ERROR : Timed Out (>$timeout secs) !</span><br />\n";
      }

/*
      if ($debug) {
        foreach ($return as $k=>$v) {
          echo '<span style="color: Green; font-weight: bold;">'."DEBUG </span> <b>Return</b> : $k: $v<br />\n";
        }
        foreach ($status as $k=>$v) {
          echo '<span style="color: Green; font-weight: bold;">'."DEBUG</span> <b>Status</b>: $k: $v<br />\n";
        }
      }
*/

   }

// -----------------------

   function checkURL($url,$withDNS=false, $info=true, $timeout=7, $debug=false) {

      mosjbdTools::verifyProtocol($url);  // Check if valid protocol is entered, if not add "HTTP://"...
      $return['code'] = "";
      $return['status'] = "";

      if (!eregi("^http://", $url) && !eregi("^https://", $url)) {
         $dnsCheck = 0;
         if (eregi("^mailto:", $url)) {
            $url = trim(eregi_replace("^mailto:(.+)", "\\1", $url));
            list($user, $host) = split("@", $url);

   //         if ($withDNS) {
               if ( mosGetParam($_SERVER, 'WINDIR', null) ) {      // For Windows platform
                  $dnsCheck = mosjbdTools::checkdnsrr_winNT($host, 'MX');
               } else {
                  $dnsCheck = @checkdnsrr($host,'MX');
               }
   //         }
   //         if ( !$withDNS || ($withDNS && $dnsCheck) ) {
            if ( $dnsCheck ) {
               $return['code'] = "200";
               $return['status'] = "DNS Result : OK";
               if ($info) { echo '<span style="color: Green; font-weight: bold;">DNS Validated...</span><br />'."\n"; }
            } else {
               $return['code'] = "404";
               $return['status'] = "DNS Result : Unknown or Time-out";
               if ($info) { echo '<span style="color: Red; font-weight: bold;">DNS Problem...</span><br />'."\n"; }
            }
         }  else {
             $return['code'] = "N/A";
             $return['status'] = "Other Protocol";
             if ($info) { echo '<span style="color: Red; font-weight: bold;">No check performed...</span><br />'."\n"; }
         }
      } else {
            $urlArray = parse_url($url);

            if (isset($urlArray['scheme']) && $urlArray['scheme'] == 'https') {
                $urlArray['port'] = 443;
            } else {
                $urlArray['port'] = isset($urlArray['port']) ? $urlArray['port'] : 80;
            }
            if ( !isset($urlArray['path']) ) { $urlArray['path'] = "/"; }

            if ($info) {
               foreach ($urlArray as $k=>$v) {
                 echo "$k: <b>$v</b><br />\n";
               }
            }

            if ($withDNS) {
               if ( mosGetParam($_SERVER, 'WINDIR', null) ) {
                  $dnsCheck = mosjbdTools::checkdnsrr_winNT($urlArray['host'],'A');
               } else {
                  $dnsCheck = checkdnsrr($urlArray['host'],'A');
               }
            }

            if ( !$withDNS || ($withDNS && $dnsCheck) ) {
               if ($urlArray['scheme'] == 'https') {  // make a SSL call
                  if ($debug) {
                     $sock = fsockopen('ssl://'.$urlArray['host'], $urlArray['port'], $errnum, $errstr, $timeout);   // Set Time-Out in secs to protect the socket opening
                  } else {
                     $sock = @fsockopen('ssl://'.$urlArray['host'], $urlArray['port'], $errnum, $errstr, $timeout);   // Set Time-Out in secs to protect the socket opening
                  }
                  if ( !isset($sock) || $sock === false || $sock == "" ) {
                     if ($info) { echo '<span style="color: Red; font-weight: bold;">Cannot open SSL:443 (SSL may not be included in this build) => check with HTTPS:80...</span><br />'."\n"; }
                     $urlArray['port'] = 80;
                     if ($debug) {
                        $sock = fsockopen($urlArray['host'], $urlArray['port'], $errnum, $errstr, $timeout);   // Set Time-Out in secs to protect the socket opening
                     } else {
                        $sock = @fsockopen($urlArray['host'], $urlArray['port'], $errnum, $errstr, $timeout);   // Set Time-Out in secs to protect the socket opening
                     }
                  }
               } else {                               // Standard HTTP call
                  if ($debug) {
                     $sock = fsockopen($urlArray['host'], $urlArray['port'], $errnum, $errstr, $timeout);   // Set Time-Out in secs to protect the socket opening
                  } else {
                     $sock = @fsockopen($urlArray['host'], $urlArray['port'], $errnum, $errstr, $timeout);   // Set Time-Out in secs to protect the socket opening
                  }
               }

               if ( !isset($sock) || $sock === false || $sock == "" ) {
                  $return['code'] = "404";
                  $return['status'] = "Page not found 404 Error (Socket error)";
                  if ($info) { echo '<span style="color: Red; font-weight: bold;">Cannot Connect to server...</span><br />'."\n"; }
               } else {     // Socket Opened !
                  if ($info) { echo '<span style="color: Green; font-weight: bold;">Connected to server...</span><br />'."\n"; }

                  // HTTP use HEAD Method
                  mosjbdTools::getHTTP($sock, $urlArray, 'HEAD', $return, $timeout, $info, $debug);
                  @fclose($sock);
                  $zz=0;
                  while ($return['code'] == '302' && $zz++ <= 10 ) {
                      if (eregi("^http://", $return['location']) || eregi("^https://", $return['location'])) {  // set new url location
                         $urlArray = parse_url($return['location']);
                      } else {
                         $urlArray['path'] = $return['location'];
                      }
                      if (isset($urlArray['scheme']) && $urlArray['scheme'] == 'https') {
                          $urlArray['port'] = 443;
                      } else {
                          $urlArray['port'] = isset($urlArray['port']) ? $urlArray['port'] : 80;
                      }
                      if ( !isset($urlArray['path']) ) { $urlArray['path'] = "/"; }
                      if ($info) { echo '<span style="color: Red; font-weight: bold;">Redirection</span> : '.$return['location'].'<br />'."\n"; }
                      if ($debug) {
                         $sock = fsockopen($urlArray['host'], $urlArray['port'], $errnum, $errstr, $timeout);   // Set Time-Out in secs to protect the socket opening
                      } else {
                         $sock = @fsockopen($urlArray['host'], $urlArray['port'], $errnum, $errstr, $timeout);   // Set Time-Out in secs to protect the socket opening
                      }
                      mosjbdTools::getHTTP($sock, $urlArray, 'HEAD', $return, $timeout, $info, $debug);
                      @fclose($sock);
                  }
                  if ($return['code'] == '405') {  // HTTP "HEAD" not allowed => use "TRACE" Method
                     if ($debug) {
                        $sock = fsockopen($urlArray['host'], $urlArray['port'], $errnum, $errstr, $timeout);   // Set Time-Out in secs to protect the socket opening
                     } else {
                        $sock = @fsockopen($urlArray['host'], $urlArray['port'], $errnum, $errstr, $timeout);   // Set Time-Out in secs to protect the socket opening
                     }
                     mosjbdTools::getHTTP($sock, $urlArray, 'TRACE', $return, $timeout, $info, $debug);
                     @fclose($sock);
                  }
                  if (!$return['code'] || $return['code'] == '403' || $return['code'] > 404 ) {  // HTTP Nothing returned with "HEAD" or "TRACE" or method not allowed => use "GET" Method
                     if ($debug) {
                        $sock = fsockopen($urlArray['host'], $urlArray['port'], $errnum, $errstr, $timeout);   // Set Time-Out in secs to protect the socket opening
                     } else {
                        $sock = @fsockopen($urlArray['host'], $urlArray['port'], $errnum, $errstr, $timeout);   // Set Time-Out in secs to protect the socket opening
                     }
                     mosjbdTools::getHTTP($sock, $urlArray, 'GET', $return, $timeout, $info, $debug);
                     @fclose($sock);
                  }
                  if (!$return['code']) {
                     $return['code'] = '404';
                     $return['status'] = "Page not found 404 Error (No code returned)";
                     if ($info) { echo '<span style="color: Red; font-weight: bold;">No code returned...</span><br />'."\n"; }
                  }
               }
            } else {
               $return['code'] = '404';
               $return['status'] = 'DNS: Non-existent Domain or Timeout';
               if ($info) { echo '<span style="color: Red; font-weight: bold;">Error : DNS Problem...</span><br />'."\n"; }
            }
      }

      if ($info) { echo "<br />\n"; }

      return $return;
   }

// -----------------------

   function validateURL ($option='com_jbd', $Itemid='0', $id, &$params, $redirurl='', $info=true) {
       global $database, $my, $acl, $mosConfig_live_site;

       $debug = $params->validationdebug;     // Show debug info ?

       // Editor usertype check
       $access = new stdClass();   // Build "Access" object
       $access->canEdit = $acl->acl_check( 'action', 'edit', 'users', strtolower($my->usertype), 'content', 'all' );
       $access->canEditOwn = $acl->acl_check( 'action', 'edit', 'users', strtolower($my->usertype), 'content', 'own' );
       $access->canPublish = $acl->acl_check( 'action', 'add', 'users', strtolower($my->usertype), 'content', 'all' );

       if (!$redirurl) {
          $redirurl='index2.php?option=com_jbd';
       }

       if ($info) {
          echo '<div align="left">'."\n";
          echo '<div class="contentheading">' ._BMU_jbd. '</div>'."\n";
       }

       $row = new mosbusiness( $database );

       $row->load( $id );

       if ($info) {
          echo '<span class="back_button"><a href="'.$redirurl.'"><b>'._BACK.'</b></a></span><br />'."\n";
          echo '<br />'."\n";
          echo ($debug) ? 'Debug : <b>ON</b><br /><br />'."\n" : "";
          echo '<u><b>jbd Validation</b></u> :<br />'."\n";
          echo 'business : <b>'.htmlspecialchars($row->title, ENT_NOQUOTES).'</b>';
          if ($Itemid) {
             if ( $access->canEdit || ( $row->created_by == $my->id && $access->canEditOwn ) || ( $params->regcaneditown && $row->created_by == $my->id ) ) {
                echo '&nbsp;<a href="index.php?option=' .$option. '&Itemid=' .$Itemid. '&task=edit&id=' .$row->id. '" title="' ._E_EDIT. ' : ' .htmlspecialchars($row->title, ENT_NOQUOTES). '">';
                echo '<img src="' .$mosConfig_live_site. '/images/M_images/edit.png" align="middle" border="0" alt="' ._E_EDIT. '" />';
                echo '</a>';
             }
          } else {
             if (strpos($redirurl,'index2.php') !== false) {  // Only for Back-end
                if ( $access->canEdit || ( $row->created_by == $my->id && $access->canEditOwn ) || ( $params->regcaneditown && $row->created_by == $my->id ) ) {
                   echo '&nbsp;<a href="' .$mosConfig_live_site. '/administrator/index2.php?option=' .$option. '&task=edititem&cid=' .$row->id. '" title="' ._E_EDIT. ' : ' .htmlspecialchars($row->title, ENT_NOQUOTES). '">';
                   echo '<img src="' .$mosConfig_live_site. '/images/M_images/edit.png" align="middle" border="0" alt="' ._E_EDIT. '" />';
                   echo '</a>';
                }
             }
          }
          echo '<br />'."\n";
          echo 'ID : [<b>'.$row->id.'</b>]<br />'."\n";
          echo 'URL : <a href="'.$row->url.'" target="_blank">'.$row->url.'</a><br />'."\n";
          echo '<br />'."\n";

          echo '<u><b>System Info</b></u> :<br />'."\n";
          echo 'PHP : <b>v'.phpversion().'</b><br />'."\n";
          echo 'jbd : <b>'.mosjbd::getVersion(false).'</b><br />'."\n";
          echo 'Timeout : <b>'.$params->urlautochecktimeout.' sec</b><br />'."\n";

          $browser = "";
          $useragent = "";
          $agenttype = mosjbdTools::checkBrowserOrBot($browser, $useragent);

          echo 'User-agent : <b>'.$useragent.'</b><br />'."\n";

          switch ($agenttype) {
            case "1" :
                echo 'User-agent Type : <b>[' .$agenttype. '] Browser (identified)</b><br />'."\n";
                break;
            case "2" :
                echo 'User-agent Type : <b>[' .$agenttype. '] Search Engine Agent</b><br />'."\n";
                break;
            default :
                echo 'User-agent Type : <b>[' .$agenttype. '] Browser</b><br />'."\n";
          }
          echo '<br />';
       }

       if ($row->url != "") {  // URL to test  and if not Manually Validated
          if ($row->validated == 1) {   // Manually Validated

             $status['code'] = "1";
             $status['status'] = "Manually Validated";
             $date = date( "Y-m-d H:i:s" );
             // Force Status to Manually Validated...
             $sql="UPDATE #__jbd SET validated = '".$status['code']."', validationdate = '".$date."', validationstatus = 'Manually Validated' WHERE id = '".$row->id."'";

             $database->setQuery( $sql );
             if (!$database->query()) {
                echo "<script type='text/javascript'> alert('ERROR : ".$database->getErrorMsg()."');  window.history.go(-1);</script>\n";
                exit;
             }

             if ($info) {
                echo '<span style="color: Orange; font-weight: bold;">Manual => No validation performed...</span><br />'."\n";
                echo '<br />'."\n";
                echo '<u><b>Status</b></u> :<br />'."\n";
                echo 'Code : <b>'.$status['code']."</b><br />\n";
                echo "Status : <b>".$status['status']."</b><br />\n";
                echo '<br />';
             }

          } else {                      // Automatic Validation

             $date = date( "Y-m-d H:i:s" );
             // update Force Initial Status to Error... Already set to Error in case of time out
             $sql="UPDATE #__jbd SET validated = '404', validationdate = '".$date."', validationstatus = 'Checking Error...' WHERE id = '".$row->id."'";

             $database->setQuery( $sql );
             if (!$database->query()) {
                echo "<script type='text/javascript'> alert('ERROR : ".$database->getErrorMsg()."');  window.history.go(-1);</script>\n";
                exit;
             }

             if ($info) { echo "<u><b>HTTP Result</b></u> :<br />\n"; }
             $status = mosjbdTools::checkURL($row->url, false, $info, $params->urlautochecktimeout, $debug);  // Check Page

             if ( $status ) {

                $date = date( "Y-m-d H:i:s" );
                // update validation status...
                $sql="UPDATE #__jbd SET validated = '".$status['code']."', validationdate = '".$date."', validationstatus = '".htmlspecialchars($status['status'], ENT_QUOTES)."' WHERE id = '".$row->id."'";

                $database->setQuery( $sql );
                if (!$database->query()) {
                   echo "<script type='text/javascript'> alert('ERROR : ".$database->getErrorMsg()."');  window.history.go(-1);</script>\n";
                   exit;
                }

                if ($info) {
                   echo '<u><b>Status</b></u> :<br />'."\n";
                   echo 'Code : <b>'.$status['code']."</b><br />\n";
                   echo "Status : <b>".$status['status']."</b><br />\n";
                   echo '<br />';

                   echo '<u><b>Page Info</b></u> :<br />'."\n";

                   $title = mosjbdTools::get_url_title($row->url, $info, $params->urlautochecktimeout, $debug);      // Retrieve : Page Title
                   echo "Title : ";
                   echo ($title) ? '<b>' .$title. '</b>' : "<i>-not present-</i>";
                   echo '<br />'."\n";

                   if ($debug) {
                      $tags = get_meta_tags ($row->url);                                                              // Retrieve : All Meta Tags
                   } else {
                      $tags = @get_meta_tags ($row->url);                                                             // Retrieve : All Meta Tags
                   }
                   echo "Meta Description (method 1) : ";
                   echo (isset($tags['description'])) ? '<b>' .$tags['description']. '</b>' : "<i>-Not Present-</i>";
                   echo '<br />'."\n";

                   $tags2 = mosjbdTools::get_meta_tags2($row->url,$info, $params->urlautochecktimeout, $debug); // Retrieve : All Meta Tags
                   echo "Meta Description (method 2) : ";
                   echo (isset($tags2['description'])) ? '<b>' .$tags2['description']. '</b>' : "<i>-Not Present-</i>";
                   echo '<br />'."\n";

   //                if ($debug) {
                      echo '<br />';
                      echo '<u><b>All Meta Tags</b></u> :<br />'."\n";
                      if ($tags2) {
                         foreach ($tags2 as $k=>$v) {
                           echo "$k => <b>$v</b><br />\n";
                         }
                      } else {
                         echo "<i>-Empty-</i><br />\n";
                      }
   //                }

                }

             }
          }
       } else {
          if ($info) { echo '<span style="color: Red;">URL is empty => No check performed...</span><br />'."\n"; }
       }

       if ($info) {
          echo '<br />'."\n";
          echo '<span class="back_button"><a href="'.$redirurl.'"><b>'._BACK.'</b></a></span><br />'."\n";

          echo '</div>'."\n";
       }
   }

// -----------------------

function isValidField (&$cols, $colname) {
   if ($cols) {
      foreach ($cols as $col) {
        if ($col->name == $colname) {
           return true;
        }
      }
   }
   return false;
}

// -----------------------

   /**
   * Load inital values in table
   */
   function initColumns ( &$cols) {
     global $database;

      // *** Add System Columns

      if ( !mosjbdTools::isValidField($cols, 'image') ) {
         $database->setQuery( "INSERT INTO #__jbd_columns (name, category, visible, visibleedit, visibledetail, visibleinfobox, ordering) VALUES ('image', '', 1, 0, 1, 1, 0)" );
         if (!$database->query()) {
            echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."');  window.history.go(-1);</script>\n";
            exit;
         }
      }

      if ( !mosjbdTools::isValidField($cols, 'icon') ) {
         $database->setQuery( "INSERT INTO #__jbd_columns (name, category, visible, visibleedit, visibledetail, visibleinfobox, ordering) VALUES ('icon', '', 1, 0, 1, 0, 1)" );
         if (!$database->query()) {
            echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."');  window.history.go(-1);</script>\n";
            exit;
         }
      }

      if ( !mosjbdTools::isValidField($cols, 'business') ) {
         $database->setQuery( "INSERT INTO #__jbd_columns (name, category, visible, visibleedit, visibledetail, visibleinfobox, ordering) VALUES ('business', '', 1, 0, 1, 1, 2)" );
         if (!$database->query()) {
            echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."');  window.history.go(-1);</script>\n";
            exit;
         }
      }

      if ( !mosjbdTools::isValidField($cols, 'description') ) {
         $database->setQuery( "INSERT INTO #__jbd_columns (name, category, visible, visibleedit, visibledetail, visibleinfobox, ordering) VALUES ('description', '', 1, 0, 1, 1, 3)" );
         if (!$database->query()) {
            echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."');  window.history.go(-1);</script>\n";
            exit;
         }
      }

      if ( !mosjbdTools::isValidField($cols, 'detail') ) {
         $database->setQuery( "INSERT INTO #__jbd_columns (name, category, visible, visibleedit, visibledetail, visibleinfobox, ordering) VALUES ('detail', '', 0, 0, 1, 0, 4)" );
         if (!$database->query()) {
            echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."');  window.history.go(-1);</script>\n";
            exit;
         }
      }

      if ( !mosjbdTools::isValidField($cols, 'category') ) {
         $database->setQuery( "INSERT INTO #__jbd_columns (name, category, visible, visibleedit, visibledetail, visibleinfobox, ordering) VALUES ('category', '', 0, 0, 1, 1, 5)" );
         if (!$database->query()) {
            echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."');  window.history.go(-1);</script>\n";
            exit;
         }
      }

      if ( !mosjbdTools::isValidField($cols, 'rating') ) {
         $database->setQuery( "INSERT INTO #__jbd_columns (name, category, visible, visibleedit, visibledetail, visibleinfobox, ordering) VALUES ('rating', '', 0, 0, 1, 1, 6)" );
         if (!$database->query()) {
            echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."');  window.history.go(-1);</script>\n";
            exit;
         }
      }

      if ( !mosjbdTools::isValidField($cols, 'hits') ) {
         $database->setQuery( "INSERT INTO #__jbd_columns (name, category, visible, visibleedit, visibledetail, visibleinfobox, ordering) VALUES ('hits', '', 1, 0, 1, 1, 7)" );
         if (!$database->query()) {
            echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."');  window.history.go(-1);</script>\n";
            exit;
         }
      }

      if ( !mosjbdTools::isValidField($cols, 'created') ) {
         $database->setQuery( "INSERT INTO #__jbd_columns (name, category, visible, visibleedit, visibledetail, visibleinfobox, ordering) VALUES ('created', '', 0, 0, 1, 1, 8)" );
         if (!$database->query()) {
            echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."');  window.history.go(-1);</script>\n";
            exit;
         }
      }

      if ( !mosjbdTools::isValidField($cols, 'created_by') ) {
         $database->setQuery( "INSERT INTO #__jbd_columns (name, category, visible, visibleedit, visibledetail, visibleinfobox, ordering) VALUES ('created_by', '', 0, 0, 1, 1, 9)" );
         if (!$database->query()) {
            echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."');  window.history.go(-1);</script>\n";
            exit;
         }
      }

      if ( !mosjbdTools::isValidField($cols, 'keywords') ) {
         $database->setQuery( "INSERT INTO #__jbd_columns (name, category, visible, visibleedit, visibledetail, visibleinfobox, ordering) VALUES ('keywords', '', 0, 0, 1, 1, 10)" );
         if (!$database->query()) {
            echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."');  window.history.go(-1);</script>\n";
            exit;
         }
      }


      return true;
   }

// -----------------------

   /**
   * Load inital values in table
   */
   function initAdminColumns ( &$adminCols) {
     global $database;


      // *** Add Admin Columns

      if ( !mosjbdTools::isValidField($adminCols, 'title') ) {
         $database->setQuery( "INSERT INTO #__jbd_columns (name, category, visible, ordering) VALUES ('title', 'admin', 2, 0)" );
         if (!$database->query()) {
            echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."');  window.history.go(-1);</script>\n";
            exit;
         }
      }

      if ( !mosjbdTools::isValidField($adminCols, 'category') ) {
         $database->setQuery( "INSERT INTO #__jbd_columns (name, category, visible, ordering) VALUES ('category', 'admin', 2, 1)" );
         if (!$database->query()) {
            echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."');  window.history.go(-1);</script>\n";
            exit;
         }
      }

      if ( !mosjbdTools::isValidField($adminCols, 'id') ) {
         $database->setQuery( "INSERT INTO #__jbd_columns (name, category, visible, ordering) VALUES ('id', 'admin', 1, 2)" );
         if (!$database->query()) {
            echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."');  window.history.go(-1);</script>\n";
            exit;
         }
      }

      if ( !mosjbdTools::isValidField($adminCols, 'testurl') ) {
         $database->setQuery( "INSERT INTO #__jbd_columns (name, category, visible, ordering) VALUES ('testurl', 'admin', 1, 3)" );
         if (!$database->query()) {
            echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."');  window.history.go(-1);</script>\n";
            exit;
         }
      }

      if ( !mosjbdTools::isValidField($adminCols, 'imageurl') ) {
         $database->setQuery( "INSERT INTO #__jbd_columns (name, category, visible, ordering) VALUES ('imageurl', 'admin', 1, 4)" );
         if (!$database->query()) {
            echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."');  window.history.go(-1);</script>\n";
            exit;
         }
      }

      if ( !mosjbdTools::isValidField($adminCols, 'rating') ) {
         $database->setQuery( "INSERT INTO #__jbd_columns (name, category, visible, ordering) VALUES ('rating', 'admin', 1, 5)" );
         if (!$database->query()) {
            echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."');  window.history.go(-1);</script>\n";
            exit;
         }
      }

      if ( !mosjbdTools::isValidField($adminCols, 'hits') ) {
         $database->setQuery( "INSERT INTO #__jbd_columns (name, category, visible, ordering) VALUES ('hits', 'admin', 1, 6)" );
         if (!$database->query()) {
            echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."');  window.history.go(-1);</script>\n";
            exit;
         }
      }

      if ( !mosjbdTools::isValidField($adminCols, 'published') ) {
         $database->setQuery( "INSERT INTO #__jbd_columns (name, category, visible, ordering) VALUES ('published', 'admin', 1, 7)" );
         if (!$database->query()) {
            echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."');  window.history.go(-1);</script>\n";
            exit;
         }
      }

      if ( !mosjbdTools::isValidField($adminCols, 'approved') ) {
         $database->setQuery( "INSERT INTO #__jbd_columns (name, category, visible, ordering) VALUES ('approved', 'admin', 1, 8)" );
         if (!$database->query()) {
            echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."');  window.history.go(-1);</script>\n";
            exit;
         }
      }

      if ( !mosjbdTools::isValidField($adminCols, 'redirect') ) {
         $database->setQuery( "INSERT INTO #__jbd_columns (name, category, visible, ordering) VALUES ('redirect', 'admin', 1, 9)" );
         if (!$database->query()) {
            echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."');  window.history.go(-1);</script>\n";
            exit;
         }
      }

      if ( !mosjbdTools::isValidField($adminCols, 'openwin') ) {
         $database->setQuery( "INSERT INTO #__jbd_columns (name, category, visible, ordering) VALUES ('openwin', 'admin', 1, 10)" );
         if (!$database->query()) {
            echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."');  window.history.go(-1);</script>\n";
            exit;
         }
      }

      if ( !mosjbdTools::isValidField($adminCols, 'private') ) {
         $database->setQuery( "INSERT INTO #__jbd_columns (name, category, visible, ordering) VALUES ('private', 'admin', 1, 11)" );
         if (!$database->query()) {
            echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."');  window.history.go(-1);</script>\n";
            exit;
         }
      }

      if ( !mosjbdTools::isValidField($adminCols, 'access') ) {
         $database->setQuery( "INSERT INTO #__jbd_columns (name, category, visible, ordering) VALUES ('access', 'admin', 1, 12)" );
         if (!$database->query()) {
            echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."');  window.history.go(-1);</script>\n";
            exit;
         }
      }

      if ( !mosjbdTools::isValidField($adminCols, 'created') ) {
         $database->setQuery( "INSERT INTO #__jbd_columns (name, category, visible, ordering) VALUES ('created', 'admin', 1, 13)" );
         if (!$database->query()) {
            echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."');  window.history.go(-1);</script>\n";
            exit;
         }
      }

      if ( !mosjbdTools::isValidField($adminCols, 'validated') ) {
         $database->setQuery( "INSERT INTO #__jbd_columns (name, category, visible, ordering) VALUES ('validated', 'admin', 1, 14)" );
         if (!$database->query()) {
            echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."');  window.history.go(-1);</script>\n";
            exit;
         }
      }

      if ( !mosjbdTools::isValidField($adminCols, 'order') ) {
         $database->setQuery( "INSERT INTO #__jbd_columns (name, category, visible, ordering) VALUES ('order', 'admin', 2, 15)" );
         if (!$database->query()) {
            echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."');  window.history.go(-1);</script>\n";
            exit;
         }
      }

      if ( !mosjbdTools::isValidField($adminCols, 'editor') ) {
         $database->setQuery( "INSERT INTO #__jbd_columns (name, category, visible, ordering) VALUES ('editor', 'admin', 1, 16)" );
         if (!$database->query()) {
            echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."');  window.history.go(-1);</script>\n";
            exit;
         }
      }

      if ( !mosjbdTools::isValidField($adminCols, 'ratingadmin') ) {
         $database->setQuery( "INSERT INTO #__jbd_columns (name, category, visible, ordering) VALUES ('ratingadmin', 'admin', 1, 17)" );
         if (!$database->query()) {
            echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."');  window.history.go(-1);</script>\n";
            exit;
         }
      }

      if ( !mosjbdTools::isValidField($adminCols, 'credits') ) {
         $database->setQuery( "INSERT INTO #__jbd_columns (name, category, visible, ordering) VALUES ('credits', 'admin', 1, 18)" );
         if (!$database->query()) {
            echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."');  window.history.go(-1);</script>\n";
            exit;
         }
      }

      return true;
   }

// -----------------------

   /**
   * Compute the category ordering
   * @param int The id of the children category
   */
   function ScanCatsTree ($parentid,&$par) {  // Scan categories
      global $database, $my;

      // ** Retrieve parent's child cats
      $database->setQuery( "SELECT bc.id, bc.title, bc.parent, bc.ordering"
                      . "\n FROM #__jbd_categories as bc"
                      . "\n WHERE bc.parent=$parentid"
                      . "\n ORDER BY bc.ordering"
      );
      $cats = $database->loadObjectList();

   //echo "DEBUG: ".$database->getQuery()."<br />\n";
   //echo "DEBUG: ordering : ".$par->ordering."<br />\n";

      $par->level++;

      foreach ($cats as $cat) {

        $par->nbcats++;

        // Build Category Name (i.e. cat/subcat/subcat2)
        $parent = &$par->parent_stack[count($par->parent_stack) - 1];
        if ($cat->id != -1) {
           $name = $parent->name . ' / ' . $cat->title;
        } else {
           $name = $cat->title;
        }

        // *** Load the Cat row from the db table
        $row = new mosbusinessCategory( $database );
        $row->loadById( $cat->id );

        if ( !$row->id ) {
           echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1);</script>\n";
           exit;
        } else {
          $row->name = $name;                 // Set full path name (Root/Cat/Subcat)
          $row->ordering = $par->ordering++;  // Set global order
          $row->store();
        }

   //for ($i=0;$i<$par->level;$i++) { echo ".."; }
   //echo "<b>Cat</b> : [$cat->id] <b>".htmlspecialchars($cat->title, ENT_NOQUOTES)."</b> => [".$row->ordering."] ".$row->name."<br />\n";

        array_push($par->parent_stack, $row);  // Add Cat to parent stack

        // *** Scan for Sub-Cats
        mosjbdTools::ScanCatsTree ($cat->id,$par);

        array_pop($par->parent_stack);  // Remove Cat from parent stack

      }

      $par->level--;

   }

// -----------------------

   function RecalcCategoriesName ($option,$task) {
      global $database;

      $par->nbcats = 0;
      $par->level = 0;
      $par->ordering = 0;

      $par->parent_stack = Array(0);
      array_push($par->parent_stack, "");  // Add Cat to parent stack

   //echo '<div align="left">'."\n";

      mosjbdTools::ScanCatsTree (-2,$par);

      array_pop($par->parent_stack);       // Remove Cat from parent stack

      $database->setQuery( "SELECT id, parent, title FROM #__jbd_categories ORDER BY id" );        // Get all Cats to rebuild the whole tree
      $cats = $database->loadObjectList();

   //echo "Processed <b>".$par->nbcats."</b> Categories<br />\n";
   //echo "TOTAL : <b>".count($cats)."</b> Categories<br />\n";

   //echo '</div><br />'."\n";

      if (count($cats) != $par->nbcats) {

         echo '<div style="color: Red;" align="left"><b>TABLE INTEGRITY ERROR</b> : [<b>jbd_Categories</b>] ==> Orphan Categories Found !!!<br />'."\n";

         echo "Available Categories [".count($cats)."] and the integrity check process found only [".$par->nbcats."] Categories...<br />\n";
         echo "Please fix ASAP !!!<br />";

         // Get all Cats to verify integrity !
         $database->setQuery( "SELECT id, parent, title"
                         . "\n FROM #__jbd_categories"
                         . "\n ORDER BY id"
         );
         $cats = $database->loadObjectList();

         echo '<ol><u>Error Report</u><br />'."\n";

         foreach ($cats as $cat) {

            $row = new mosbusinessCategory( $database );

            if ($cat->id != -1) {
               $row->loadById( $cat->parent );
            } else {    // Fake Root Cat, as it has no exisitng parent... parent = -2
               $row->id = -2;
               $row->ordering = 0;
               $row->title = "Root's Parent";
            }

   // echo "DEBUG: [".$cat->id."] ".$cat->title." => parent [".$cat->parent."] => [".$row->id."] ".$row->title." <br />\n";

               if (!$row->id || $cat->parent != $row->id) {
                 echo "<li>[ID: <b>" .$cat->id. "</b>] <b>" .htmlspecialchars($cat->title, ENT_NOQUOTES). "</b> has a deleted parent ==> Parent: <b>".$cat->parent."</b> !!!</li>\n";
               } elseif ( $cat->id == $cat->parent ) {
                 echo "<li>[ID: <b>" .$cat->id. "</b>] <b>" .htmlspecialchars($cat->title, ENT_NOQUOTES). "</b> cannot be its own parent ==> Parent: <b>".$cat->parent."</b> !!!</li>\n";
               }
         }
         echo "</ol>";
         echo "</div>";

         echo '<br />';
         echo '<span class="back_button"><a href="index2.php?option='.$option.'&task='.$task.'"><b>'._BACK.'</b></a></span>';

         exit;
      }
   }

// -----------------------

   /**
   * Load inital values in table
   */
   function initRootCat () {
      global $database;

      // Add Root Cat document...  ID = -1 / Parent = -2
      $database->setQuery( "INSERT INTO #__jbd_categories (id, title, name, published, ordering, parent, image, image_position) VALUES (-1, 'Root', 'Root', 1, 1, -2, '', 'left')" );
      if (!$database->query()) {
         echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1);</script>\n";
         exit;
      }

   /*
      // WORKAROUND : Force to Set Root Cat ID to 0, as auto_increment set the ID to MAX(id)+1 and does not directly allow "0"...
      $database->setQuery( "UPDATE #__jbd_categories SET id=-1 WHERE title='Root'" );
      if (!$database->query()) {
         echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1);</script>\n";
         exit;
      }
   */

      // Recalc all Subcats tree (name field to add the Root Cat)

      if (!isset($option)) { $option = "com_jbd"; }     // protection in case of empty table (first call)...
      mosjbdTools::RecalcCategoriesName($option,"");

      return true;
   }

// -----------------------

   function imageArrow() {
      global $mosConfig_absolute_path, $mosConfig_live_site, $mainframe;

      $imgPath =  '/templates/' . $mainframe->getTemplate() . '/images/arrow.png';
      if ( file_exists( $mosConfig_absolute_path . $imgPath ) ) {
         $img = '<img src="' .$mosConfig_live_site . $imgPath. '" border="0" alt="" />';
      } else {
         $imgPath = '/images/M_images/arrow.png';
         if ( file_exists( $mosConfig_absolute_path . $imgPath ) ) {
            $img = '<img src="' .$mosConfig_live_site . $imgPath. '" border="0" alt="" />';
         } else {
            $img = '&gt;';
         }
      }
      return $img;
   }

// -----------------------

   function newOPCAction ($category, $action, $pic, $title, $help) {

     $obj->category = $category;
     $obj->action = $action;
     $obj->pic = $pic;
     $obj->title = $title;
     $obj->desc = $help;

     return $obj;
   }

// -----------------------

   function initOPCActions (&$actions) {


     $actions[] = mosjbdTools::newOPCAction('tables',    'dbintegrity',  'reload_f2.png', _BM_OPC_DBINTEGRITY, _BM_OPC_DBINTEGRITY_HELP);
     $actions[] = mosjbdTools::newOPCAction('tables',    'resetcfg',     'reload_f2.png', _BM_OPC_RESETCFG, _BM_OPC_RESETCFG_HELP);
     $actions[] = mosjbdTools::newOPCAction('tables',    'cleartables',  'reload_f2.png', _BM_OPC_CLEARTABLES, _BM_OPC_CLEARTABLES_HELP);

     $actions[] = mosjbdTools::newOPCAction('queries',   'openparent',   'reload_f2.png', _BM_OPC_OPENWIN_PARENT, _BM_OPC_OPENWIN_PARENT_HELP);
     $actions[] = mosjbdTools::newOPCAction('queries',   'opennew',      'reload_f2.png', _BM_OPC_OPENWIN_NEW, _BM_OPC_OPENWIN_NEW_HELP);
     $actions[] = mosjbdTools::newOPCAction('queries',   'openwrapper',  'reload_f2.png', _BM_OPC_OPENWIN_WRAPPER, _BM_OPC_OPENWIN_WRAPPER_HELP);
     $actions[] = mosjbdTools::newOPCAction('queries',   'redirurl',     'reload_f2.png', _BM_OPC_REDIRECT_URL, _BM_OPC_REDIRECT_URL_HELP);
     $actions[] = mosjbdTools::newOPCAction('queries',   'redirdetail',  'reload_f2.png', _BM_OPC_REDIRECT_DETAIL, _BM_OPC_REDIRECT_DETAIL_HELP);

     $actions[] = mosjbdTools::newOPCAction('snapshot',  'clearsnap',    'reload_f2.png', _BM_OPC_CLEAR_SNAP, _BM_OPC_CLEAR_SNAP_HELP);
     $actions[] = mosjbdTools::newOPCAction('snapshot',  'clearforce',   'reload_f2.png', _BM_OPC_CLEAR_FORCE, _BM_OPC_CLEAR_FORCE_HELP);
     $actions[] = mosjbdTools::newOPCAction('snapshot',  'snapempty',    'reload_f2.png', _BM_OPC_SNAPSHOT_EMPTY, _BM_OPC_SNAPSHOT_EMPTY_HELP);
     $actions[] = mosjbdTools::newOPCAction('snapshot',  'snapforce',    'reload_f2.png', _BM_OPC_SNAPSHOT_FORCE, _BM_OPC_SNAPSHOT_FORCE_HELP);
     $actions[] = mosjbdTools::newOPCAction('snapshot',  'snapconvert',  'reload_f2.png', _BM_OPC_SNAPSHOT_CONVERT, _BM_OPC_SNAPSHOT_CONVERT_HELP);

     $actions[] = mosjbdTools::newOPCAction('misc',      'menuicons',    'reload_f2.png', _BM_OPC_MENUICONS, _BM_OPC_MENUICONS_HELP);
     $actions[] = mosjbdTools::newOPCAction('misc',      'menuiconsoff', 'reload_f2.png', _BM_OPC_MENUICONSOFF, _BM_OPC_MENUICONSOFF_HELP);

   }


// -----------------------

   function checkBrowserOrBot ( &$browser, &$UserAgent ) {
     // *** Determine if the userAgent is a [1:Browser] or [2:Bot]

     global $database, $mosConfig_absolute_path;

     $type = 0;

     // *** Retrieve the UserAgent ...
     // Get user agent
     $UserAgent = '';
     if (isset($_SERVER['HTTP_USER_AGENT'])) {
        if ($_SERVER['HTTP_USER_AGENT'] != NULL) {
           $UserAgent = strtolower($_SERVER['HTTP_USER_AGENT']);
        }
     }

     $type = 0;

     $browser='';

     if (file_exists($mosConfig_absolute_path."/components/com_tfsformambo/tfsformambo.php")) {
        // *** TFSforMambo is an advanced statisic Mambo Component => MamboForge.
        $sql = 'SELECT SQL_BIG_RESULT LENGTH( browser_string ) AS strlen, browser_string, browser_fullname FROM #__TFS_browsers ORDER BY strlen DESC';
        $database->setQuery($sql);
        $rs = $database->query();
        while ($r_row = mysql_fetch_array($rs)) {
          if (strpos($UserAgent,$r_row['browser_string']) !== false) {
             $browser = mysql_escape_string($r_row['browser_fullname']);
             if (preg_match( "/".$brow['browser_string']."[\/\sa-z]*([\d\.]*)/i", $UserAgent, $version)) {
                $browser .= ' '.$version[1];
             }
             $type = 1;
             break;
          }
        }

        mysql_free_result($rs);

        if ($browser == '') {

           // get bot
           $sql = 'SELECT SQL_BIG_RESULT LENGTH(bot_string) AS strlen, bot_string,bot_fullname FROM #__TFS_bots ORDER BY strlen DESC';

           $database->setQuery($sql);
           $rs = $database->query();

           while ($r_row = mysql_fetch_array($rs)) {
             if (strpos($UserAgent,$r_row['bot_string']) !== false) {
                $browser = mysql_escape_string($r_row['bot_fullname']);
                $type = 2;
                break;
             }
           }

           mysql_free_result($rs);
        }
     } // end TFSforMambo checks...


     // *** Basic Generic Identification, if the agent is not yet idenfied by TFSforMambo or TFSforMambo is not installed !
     $keywords = array();
     $keywords[] = 'robot';
     $keywords[] = 'bot';
     $keywords[] = 'crawl';
     $keywords[] = 'spider';
     $keywords[] = 'index';
     $keywords[] = 'slurp';

     foreach ($keywords as $keyword) {
        if (strpos($UserAgent,$keyword) !== false) {
           $browser = 'Generic Robot ['.$keyword.']';
           $type = 2;
           break;
        }
     }

     return $type;

   } // End function


// -----------------------


}  // End Class Toolbox

?>